import {StoryMoment, Passage} from "twine-sugarcube";

declare module "twine-sugarcube" {
	interface SugarCubeStoryVariables extends FC.GameVariables {
	}

	interface SugarCubeSetupObject {
		ArcologyNamesSupremacistWhite: string[];
		ArcologyNamesSupremacistAsian: string[];
		ArcologyNamesSupremacistLatina: string[];
		ArcologyNamesSupremacistMiddleEastern: string[];
		ArcologyNamesSupremacistBlack: string[];
		ArcologyNamesSupremacistIndoAryan: string[];
		ArcologyNamesSupremacistPacificIslander: string[];
		ArcologyNamesSupremacistMalay: string[];
		ArcologyNamesSupremacistAmerindian: string[];
		ArcologyNamesSupremacistSouthernEuropean: string[];
		ArcologyNamesSupremacistSemitic: string[];
		ArcologyNamesSupremacistMixedRace: string[];
		ArcologyNamesSubjugationistWhite: string[];
		ArcologyNamesSubjugationistAsian: string[];
		ArcologyNamesSubjugationistLatina: string[];
		ArcologyNamesSubjugationistMiddleEastern: string[];
		ArcologyNamesSubjugationistBlack: string[];
		ArcologyNamesSubjugationistIndoAryan: string[];
		ArcologyNamesSubjugationistPacificIslander: string[];
		ArcologyNamesSubjugationistMalay: string[];
		ArcologyNamesSubjugationistAmerindian: string[];
		ArcologyNamesSubjugationistSouthernEuropean: string[];
		ArcologyNamesSubjugationistSemitic: string[];
		ArcologyNamesSubjugationistMixedRace: string[];
		ArcologyNamesGenderRadicalist: string[];
		ArcologyNamesGenderFundamentalist: string[];
		ArcologyNamesPaternalist: string[];
		ArcologyNamesDegradationist: string[];
		ArcologyNamesAssetExpansionist: string[];
		ArcologyNamesSlimnessEnthusiast: string[];
		ArcologyNamesTransformationFetishist: string[];
		ArcologyNamesBodyPurist: string[];
		ArcologyNamesMaturityPreferentialist: string[];
		ArcologyNamesYouthPreferentialistLow: string[];
		ArcologyNamesYouthPreferentialist: string[];
		ArcologyNamesPastoralist: string[];
		ArcologyNamesPhysicalIdealist: string[];
		ArcologyNamesChattelReligionist: string[];
		ArcologyNamesRomanRevivalist: string[];
		ArcologyNamesNeoImperialist: string[];
		ArcologyNamesAztecRevivalist: string[];
		ArcologyNamesEgyptianRevivalist: string[];
		ArcologyNamesEdoRevivalist: string[];
		ArcologyNamesArabianRevivalist: string[];
		ArcologyNamesChineseRevivalist: string[];
		ArcologyNamesRepopulationist: string[];
		ArcologyNamesEugenics: string[];
		ArcologyNamesHedonisticDecadence: string[];
		ArcologyNamesIntellectualDependency: string[];
		ArcologyNamesSlaveProfessionalism: string[];
		ArcologyNamesPetiteAdmiration: string[];
		ArcologyNamesStatuesqueGlorification: string[];

		badWords: string[];
		badNames: string[];
		chattelReligionistSlaveNames: string[];
		romanSlaveNames: string[];
		romanSlaveSurnames: string[];
		aztecSlaveNames: string[];
		ancientEgyptianSlaveNames: string[];
		edoSlaveNames: string[];
		edoSlaveSurnames: string[];
		bimboSlaveNames: string[];
		cowSlaveNames: string[];
		whiteAmericanMaleNames: string[];
		whiteAmericanSlaveNames: string[];
		whiteAmericanSlaveSurnames: string[];

		attendantCareers: string[];
		bodyguardCareers: string[];
		DJCareers: string[];
		educatedCareers: string[];
		entertainmentCareers: string[];
		facilityCareers: string[];
		farmerCareers: string[];
		gratefulCareers: string[];
		HGCareers: string[];
		madamCareers: string[];
		matronCareers: string[];
		menialCareers: string[];
		milkmaidCareers: string[];
		nurseCareers: string[];
		recruiterCareers: string[];
		schoolteacherCareers: string[];
		servantCareers: string[];
		stewardessCareers: string[];
		uneducatedCareers: string[];
		veryYoungCareers: string[];
		wardenessCareers: string[];
		whoreCareers: string[];
		youngCareers: string[];

		fakeBellies: string[];
		filterRacesLowercase: FC.Race[];
		heightBoostingShoes: string[];
		highHeels: string[];
		humiliatingClothes: string[];
		modestClothes: string[];
		sluttyClothes: string[];

		pregData: Record<string, FC.PregnancyData>;

		malenamePoolSelector: Record<string, string[]>;
		maleSurnamePoolSelector: Record<string, string[]>;
		namePoolSelector: Record<string, string[]>;
		surnamePoolSelector: Record<string, string[]>;
		raceSelector: Record<string, Record<FC.Race, number>>;

		naturalSkins: string[];
		naturalNippleColors: string[];

		pettyCriminalPool: string[];
		gangCriminalPool: string[];
		militaryCriminalPool: string[];
		whiteCollarCriminalPool: string[];

		baseNationalities: string[];
		paraphiliaList: string[]; // actually FC.SexualFlaw[]
		prosthetics: Record<string, FC.Data.ProsteticDefinition>;
	}

	// These are SugarCube private APIs used in the project
	interface StateAPI {
		expired: StoryMoment[];
		clearTemporary(): void;
	}

	interface UIBarAPI {
		update(): void;
	}
}

export {};
