App.SecExp.initTrade = function() {
	if (V.SecExp.core.trade === 0 || !jsDef(V.SecExp.core.trade)) {
		let init = jsRandom(20, 30);
		if (V.terrain === "urban") {
			init += jsRandom(10, 10);
		} else if (V.terrain === "ravine") {
			init -= jsRandom(5, 5);
		}
		if (["BlackHat", "capitalist", "celebrity", "wealth"].includes(V.PC.career)) {
			init += jsRandom(5, 5);
		} else if (["escort", "gang", "servant"].includes(V.PC.career)) {
			init -= jsRandom(5, 5);
		}
		V.SecExp.core.trade = init;
	}
};

App.SecExp.generalInit = function(){
	if (V.secExpEnabled === 0) {
		return;
	}

	Object.assign(V.SecExp, {
		/*
		battles: {
			major: 0,
			slaveVictories : [],
			victories: 0,
			victoryStreak: 0,
			losses: 0,
			lossStreak: 0,
			lastEncounterWeeks: 0,
			saved: {}
		}, */
		rebellions: {
			tension: 0,
			slaveProgress: 0,
			citizenProgress: 0,
			// victories: 0,
			// losses: 0,
			// lastEncounterWeeks: 0
		},
		core: {
			trade: 0,
			authority: 0,
			security: 100,
			crimeLow: 30,
			totalKills: 0,
		},
		settings: {
			difficulty: 1,
			unitDescriptions: 0,
			battle: {
				enabled: 1,
				allowSlavePrestige: 1,
				force: 0,
				showStats: 0,
				frequency: 1,
				major: {
					enabled: 0,
					gameOver: 1,
					mult: 1,
					force: 0
				}
			},
			rebellion: {
				enabled: 1,
				force: 0,
				gameOver: 1,
				speed: 1
			}
		},
		buildings: {},
		proclamation: {
			cooldown: 0,
			currency: "",
			type: "crime"
		},
		/*
		repairTime: {
			waterway: 0,
			assistant: 0,
			reactor: 0,
			arc: 0
		},
		units: {
			bots: {},
			slaves: {
				created: 0,
				casualties: 0,
				sqauds: []
			},
			milita: {
				created: 0,
				free: 0,
				casualties: 0,
				sqauds: []
			},
			mercs: {
				created: 0,
				free: 0,
				casualties: 0,
				sqauds: []
			}
		},
		*/
		edicts: {
			alternativeRents: 0,
			enslavementRights: 0,
			sellData: 0,
			propCampaignBoost: 0,
			tradeLegalAid: 0,
			taxTrade: 0,
			slaveWatch: 0,
			subsidyChurch: 0,
			SFSupportLevel: 0,
			limitImmigration: 0,
			openBorders: 0,
			weaponsLaw: 3,
			defense: {
				soldierWages: 1,
				slavesOfficers: 0,
				discountMercenaries: 0,
				militia: 0,
				militaryExemption: 0,
				noSubhumansInArmy: 0,
				pregExemption: 0,
				liveTargets: 0,
				privilege: {
					militiaSoldier: 0,
					slaveSoldier: 0,
					mercSoldier: 0,
				},
				// Soldiers
				martialSchool: 0,
				eliteOfficers: 0,
				lowerRequirements: 0,
				// FS soldiers
				legionTradition: 0,
				eagleWarriors: 0,
				ronin: 0,
				sunTzu: 0,
				mamluks: 0,
				pharaonTradition: 0,
			}
		},
		smilingMan: { progress : 0 },
		defaultNames: {
			slaves: "slave platoon",
			milita: "citizens' platoon",
			mercs: "mercenary platoon"
		}
	});

	App.SecExp.initTrade();
};

App.SecExp.upkeep = (function() {
	return {
		edictsCash,
		edictsAuth,
		SF,
		buildings
	};

	/** Upkeep cost of edicts, in cash
	 * @returns {number}
	 */
	function edictsCash() {
		let value = 0;
		if (V.SecExp.edicts.slaveWatch) { value++; }
		if (V.SecExp.edicts.subsidyChurch) { value++; }
		if (V.SecExp.edicts.tradeLegalAid) { value++; }
		if (V.SecExp.edicts.propCampaignBoost) { value++; }

		if (V.SecExp.edicts.defense.martialSchool) { value++; }

		if (V.SecExp.edicts.defense.legionTradition) { value++; }
		if (V.SecExp.edicts.defense.pharaonTradition) { value++; }
		if (V.SecExp.edicts.defense.eagleWarriors) { value++; }
		if (V.SecExp.edicts.defense.ronin) { value++; }
		if (V.SecExp.edicts.defense.mamluks) { value++; }
		if (V.SecExp.edicts.defense.sunTzu) { value++; }

		return value*1000;
	}

	/** Upkeep cost of edicts, in authority
	 * @returns {number}
	 */
	function edictsAuth() {
		let value = 0;
		if (V.SecExp.edicts.enslavementRights > 0) {
			value += 10;
		}
		if (V.SecExp.edicts.sellData === 1) {
			value += 10;
		}
		if (V.SecExp.edicts.defense.privilege.slaveSoldier === 1) {
			value += 10;
		}
		if (V.SecExp.edicts.weaponsLaw === 0) {
			value += 30;
		} else if (V.SecExp.edicts.weaponsLaw === 1) {
			value += 20;
		} else if (V.SecExp.edicts.weaponsLaw === 2) {
			value += 10;
		}
		if (V.SecExp.edicts.defense.slavesOfficers === 1) {
			value += 10;
		}
		return value;
	}

	/** Upkeep cost of Special Forces (why is this here? who knows!)
	 * @returns {number}
	 */
	function SF() {
		let value = 0;
		if (V.SecExp.edicts.SFSupportLevel >= 1) {
			value += 1000;
		}
		if (V.SecExp.edicts.SFSupportLevel >= 2) {
			value += 2000;
		}
		if (V.SecExp.edicts.SFSupportLevel >= 3) {
			value += 3000;
		}
		if (V.SecExp.edicts.SFSupportLevel >= 4) {
			value += 3000;
		}
		if (V.SecExp.edicts.SFSupportLevel >= 5) {
			value += 4000;
		}
		return value;
	}

	/** Upkeep cost of buildings (in cash)
	 * @returns {number}
	 */
	function buildings() {
		let value = 0;
		const base = V.facilityCost * 5, upgrade = 50;
		if (V.SecExp.buildings.propHub) {
			value += base + upgrade * Object.values(V.SecExp.buildings.propHub.upgrades).reduce((a, b) => a + b);
		}
		if (V.SecExp.buildings.secHub) {
			value += base + 20 * V.SecExp.buildings.secHub.menials;
			value += upgrade * Object.values(V.SecExp.buildings.secHub.upgrades.security).reduce((a, b) => a + b);
			value += upgrade * Object.values(V.SecExp.buildings.secHub.upgrades.crime).reduce((a, b) => a + b);
			value += upgrade * Object.values(V.SecExp.buildings.secHub.upgrades.readiness).reduce((a, b) => a + b);
			value += upgrade * Object.values(V.SecExp.buildings.secHub.upgrades.intel).reduce((a, b) => a + b);
			value += V.SecExp.edicts.SFSupportLevel >= 5 ? 1000 : 0;
		}
		if (V.SecExp.buildings.barracks) {
			value += base + upgrade* Object.values(V.SecExp.buildings.barracks).reduce((a, b) => a + b);
		}
		if (V.SecExp.buildings.riotCenter) {
			value += base + upgrade* Object.values(V.SecExp.buildings.riotCenter.upgrades).reduce((a, b) => a + b);
			if (V.SecExp.buildings.riotCenter.brainImplant < 106 && V.SecExp.buildings.riotCenter.brainImplantProject > 0) {
				value += 5000 * V.SecExp.buildings.riotCenter.brainImplantProject;
			}
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.rebellions.sfArmor) {
				value += 15000;
			}
		}
		return value;
	}
})();

App.SecExp.battle = (function() {
	"use strict";
	return {
		deployedUnits,
		troopCount,
		deploySpeed,
		deployableUnits,
		activeUnits,
		maxUnits,
		recon,
		bribeCost,
	};

	/** Get count of deployed/active units for a particular battle
	 * @param {string} [input] unit type to measure; if omitted, count all types
	 * @returns {number} unit count
	 */
	function deployedUnits(input = '') {
		let bots = 0, militiaC = 0, slavesC = 0, mercsC = 0, init = 0;
		if (V.slaveRebellion !== 1 && V.citizenRebellion !== 1) { // attack
			if (V.secBots.isDeployed > 0) {
				bots++;
			}
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SFIntervention) {
				init++;
			}

			militiaC += V.militiaUnits.filter((u) => u.isDeployed === 1).length;
			slavesC += V.slaveUnits.filter((u) => u.isDeployed === 1).length;
			mercsC += V.mercUnits.filter((u) => u.isDeployed === 1).length;
		} else { // rebellion
			if (V.secBots.active > 0) {
				bots++;
			}
			if (V.SF.Toggle && V.SF.Active >= 1) {
				init++;
			}
			if (V.irregulars > 0) {
				militiaC++;
			}

			militiaC += V.militiaUnits.filter((u) => u.active === 1 && !V.rebellingID.includes(u.ID)).length;
			slavesC += V.slaveUnits.filter((u) => u.active === 1 && !V.rebellingID.includes(u.ID)).length;
			mercsC += V.mercUnits.filter((u) => u.active === 1 && !V.rebellingID.includes(u.ID)).length;
		}

		if (input === '') {
			return bots+militiaC+slavesC+mercsC+init;
		} else if (input === 'bots') {
			return bots;
		} else if (input === 'militia') {
			return militiaC;
		} else if (input === 'slaves') {
			return slavesC;
		} else if (input === 'mercs') {
			return mercsC;
		}
	}

	/** Get total troop count of deployed/active units for a particular battle
	 * @returns {number} troop count
	 */
	function troopCount() {
		let troops = 0;

		/** @param {function(FC.SecExp.PlayerHumanUnitData) : boolean} pred */
		function countHumanTroops(pred) {
			const arrays = [V.militiaUnits, V.slaveUnits, V.mercUnits];
			for (const arr of arrays) {
				for (const unit of arr) {
					if (pred(unit)) {
						troops += unit.troops;
					}
				}
			}
		}

		if (V.slaveRebellion !== 1 && V.citizenRebellion !== 1) { // attack
			if (V.secBots.isDeployed === 1) {
				troops += V.secBots.troops;
			}
			countHumanTroops((u) => u.isDeployed === 1);
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SFIntervention) {
				troops += App.SecExp.troopsFromSF();
			}
		} else {
			if (V.irregulars > 0) {
				troops += V.irregulars;
			}
			if (V.secBots.active === 1) {
				troops += V.secBots.troops;
			}
			countHumanTroops((u) => u.active === 1 && !V.rebellingID.includes(u.ID));
			if (V.SF.Toggle && V.SF.Active >= 1) {
				troops += App.SecExp.troopsFromSF();
			}
		}
		return troops;
	}

	/** Get mobilization readiness (in *pairs* of units) given upgrades
	 * @returns {number} readiness
	 */
	function deploySpeed() {
		let init = 1;
		if (V.SecExp.buildings.secHub) {
			if (V.SecExp.buildings.secHub.upgrades.readiness.pathways > 0) {
				init += 1;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.rapidVehicles > 0) {
				init += 2;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.rapidPlatforms > 0) {
				init += 2;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.earlyWarn > 0) {
				init += 2;
			}
		}
		if (V.SF.Toggle && V.SF.Active >= 1 && V.sectionInFirebase >= 1) {
			init += 2;
		}
		return init;
	}

	/** Get remaining deployable units (mobilization in units minus units already deployed)
	 * @returns {number}
	 */
	function deployableUnits() {
		let init = 2 * App.SecExp.battle.deploySpeed();
		if (V.secBots.isDeployed > 0) {
			init--;
		}

		const Militia = V.militiaUnits.length;
		for (let i = 0; i < Militia; i++) {
			if (V.militiaUnits[i].isDeployed > 0) {
				init--;
			}
		}

		const Slaves = V.slaveUnits.length;
		for (let i = 0; i < Slaves; i++) {
			if (V.slaveUnits[i].isDeployed > 0) {
				init--;
			}
		}

		const Mercs = V.mercUnits.length;
		for (let i = 0; i < Mercs; i++) {
			if (V.mercUnits[i].isDeployed > 0) {
				init--;
			}
		}

		return Math.max(0, init);
	}

	/** Get total active units
	 * @returns {number}
	 */
	function activeUnits() {
		return V.secBots.active + V.militiaUnits.length + V.slaveUnits.length + V.mercUnits.length;
	}

	/** Get maximum active units
	 * @returns {number}
	 */
	function maxUnits() {
		let max = 0;
		if (V.SecExp.buildings.barracks) {
			max = 8 + (V.SecExp.buildings.barracks.size * 2);
			if(App.SecExp.battle.deploySpeed() === 10) {
				max += 2;
			}
		}
		return max;
	}

	/** Get recon score (scale 0-3)
	 * @returns {number}
	 */
	function recon() {
		return V.SecExp.buildings.secHub ? Object.values(V.SecExp.buildings.secHub.upgrades.intel).reduce((a, b) => a + b) : 0;
	}

	/** Get bribe cost for an attacker to go away
	 * @returns {number}
	 */
	function bribeCost() {
		let cost; const baseBribePerAttacker = 5;
		if (V.week <= 30) {
			cost = 5000 + baseBribePerAttacker * V.attackTroops;
		} else if (V.week <= 40) {
			cost = 10000 + baseBribePerAttacker * V.attackTroops;
		} else if (V.week <= 50) {
			cost = 15000 + baseBribePerAttacker * V.attackTroops;
		} else if (V.week <= 60) {
			cost = 20000 + baseBribePerAttacker * V.attackTroops;
		} else if (V.week <= 70) {
			cost = 25000 + baseBribePerAttacker * V.attackTroops;
		} else {
			cost = 30000 + baseBribePerAttacker * V.attackTroops;
		}
		cost *= V.majorBattle > 0 ? 3 : 1;
		return Math.trunc(Math.clamp(cost, 0, 1000000));
	}
})();

App.SecExp.Check = (function() {
	"use strict";
	return {
		secRestPoint,
		crimeCap,
		reqMenials,
	};

	function secRestPoint() {
		let rest = 40;
		if (V.SecExp.buildings.secHub) {
			if (V.SecExp.buildings.secHub.upgrades.security.nanoCams === 1) {
				rest += 15;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.cyberBots === 1) {
				rest += 15;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.eyeScan === 1) {
				rest += 20;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.cryptoAnalyzer === 1) {
				rest += 20;
			}
		}
		return rest;
	}

	function crimeCap() {
		let cap = 100;
		if (V.SecExp.buildings.secHub) {
			if (V.SecExp.buildings.secHub.upgrades.crime.autoTrial === 1) {
				cap -= 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.autoArchive === 1) {
				cap -= 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.worldProfiler === 1) {
				cap -= 15;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.advForensic === 1) {
				cap -= 15;
			}
		}
		return cap;
	}

	function reqMenials() {
		let Req = 20;
		if (V.SecExp.buildings.secHub) {
			if (V.SecExp.buildings.secHub.upgrades.security.nanoCams === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.cyberBots === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.eyeScan === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.cryptoAnalyzer === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.autoTrial === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.autoArchive === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.worldProfiler === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.advForensic === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.intel.sensors === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.intel.signalIntercept === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.intel.radar === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.rapidVehicles === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.rapidPlatforms === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.earlyWarn === 1) {
				Req += 10;
			}
			Req -= 5 * V.SecExp.edicts.SFSupportLevel;
			Req -= 10 * V.SecExp.buildings.secHub.coldstorage;
		}
		return Req;
	}
})();

App.SecExp.inflictBattleWound = (function() {
	/** @typedef {object} Wound
	 * @property {number} weight
	 * @property {function(App.Entity.SlaveState):boolean} allowed
	 * @property {function(App.Entity.SlaveState):void} effects
	 */
	/** @type { Object<string, Wound> } */
	const wounds = {
		eyes: {
			weight: 10,
			allowed: (s) => canSee(s),
			effects: (s) => { clampedDamage(s, 30); eyeSurgery(s, "both", "blind"); }
		},
		voice: {
			weight: 10,
			allowed: (s) => canTalk(s),
			effects: (s) => { clampedDamage(s, 60); s.voice = 0; }
		},
		legs: {
			weight: 5,
			allowed: (s) => hasAnyNaturalLegs(s),
			effects: (s) => { clampedDamage(s, 80); removeLimbs(s, "left leg"); removeLimbs(s, "right leg"); }
		},
		arm: {
			weight: 5,
			allowed: (s) => hasAnyNaturalArms(s),
			effects: (s) => { clampedDamage(s, 60); removeLimbs(s, jsEither(["left arm", "right arm"])); }
		},
		flesh: {
			weight: 70,
			allowed: () => true,
			effects: (s) => { clampedDamage(s, 30); }
		}
		// TODO: add more wound types? destroy prosthetics?
	};

	/** Inflicts a large amount of damage upon a slave without killing them (i.e. leaving their health total above -90)
	 * @param {App.Entity.SlaveState} slave
	 * @param {number} magnitude
	 */
	function clampedDamage(slave, magnitude) {
		if ((slave.health.health - magnitude) > -90) {
			healthDamage(slave, magnitude);
		} else {
			healthDamage(slave, 90 + slave.health.health);
		}
	}

	/** Inflicts a wound upon a slave during a battle.  Returns the wound type from the wound table (see above) so it can be described.
	 * @param {App.Entity.SlaveState} slave
	 * @returns {string}
	 */
	function doWound(slave) {
		let woundHash = {};
		for (const w of Object.keys(wounds)) {
			if (wounds[w].allowed(slave)) {
				woundHash[w] = wounds[w].weight;
			}
		}
		/** @type {string} */
		// @ts-ignore - FIXME: hashChoice has bad JSDoc
		const wound = hashChoice(woundHash);
		wounds[wound].effects(slave);
		return wound;
	}

	return doWound;
})();
