/**
 * Generates (and returns if not silent) a standard slave report
 * @param {App.Entity.SlaveState} slave
 * @param {boolean} silent
 * @returns {HTMLElement|null}
 */
App.SlaveAssignment.standardSlaveReport = function(slave, silent=false) {
	const
		clothes = App.SlaveAssignment.choosesOwnClothes(slave);

	tired(slave);

	const
		rules = App.UI.DOM.renderPassage("SA rules"),
		diet = App.SlaveAssignment.diet(slave),
		ltEffects = App.UI.DOM.renderPassage("SA long term effects"),
		drugs = App.SlaveAssignment.drugs(slave),
		relationships = App.SlaveAssignment.relationships(slave),
		rivalries = App.SlaveAssignment.rivalries(slave),
		devotion = App.SlaveAssignment.devotion(slave);

	if (!silent) {
		const content = App.UI.DOM.makeElement("div", '', "indent");

		$(content).append(clothes, rules, diet, ltEffects, drugs, relationships, rivalries, `<div class="indent">${devotion}</div>`);

		return content;
	}
};
