/**
 * @param {App.Entity.SlaveState} slave
 * @returns {number}
 */
App.Facilities.Farmyard.foodAmount = function(slave) {
	let food = 150;

	if (!slave) {
		throw `Current slave is not valid. Please report this`;
	}

	if (V.farmyardUpgrades.pump) {
		food += 15;
	}

	if (V.farmyardUpgrades.fertilizer) {
		food += 35;
	}

	if (V.farmyardUpgrades.seeds) {
		food += 65;
	}

	if (V.farmyardUpgrades.machinery) {
		food += 65;
	}

	if (S.Farmer) {
		food *= 1.1;

		if (S.Farmer.skill.farmer >= V.masteredXP) {
			food *= 1.2;
		}

		if (setup.farmerCareers.includes(S.Farmer.career)) {
			food *= 1.2;
		}
	}

	if (slave.devotion > 50) {
		food *= 1.1;
	} else if (slave.devotion < -50) {
		food *= 0.8;
	}

	if (slaveResting(slave)) {
		food *= 0.9;
	} else if (slave.health.tired + 20 >= 90 && !willWorkToDeath(slave)) {
		slave.devotion -= 10;
		slave.trust -= 5;
		food *= 0.9;
	}

	if (slave.muscles > 30) {										// slave is muscular or more
		food *= 1.1;
	} else if (slave.muscles <= -6) {								// slave is weak or less
		food *= 0.8;
	}

	if (slave.weight > 95) {										// slave is overweight or more
		food *= 0.9;
	} else if (slave.weight > 130) {								// slave is fat or more
		food *= 0.8;
	} else if (slave.weight > 160) {								// slave is obese or more
		food *= 0.7;
	} else if (slave.weight > 190) {								// slave is very obese or more
		food *= 0.6;
	}

	if (!canSee(slave)) {											// slave is blind
		food *= 0.6;
	} else if (!canSeePerfectly(slave)) {							// slave is nearsighted
		food *= 0.8;
	}

	if (slave.hears === -1) {										// slave is hard of hearing
		food *= 0.8;
	} else if (slave.hears < -1) {									// slave is deaf
		food *= 0.6;
	}

	food *= restEffects(slave, 20);
	food = Math.trunc(Math.max(food, 1));

	return food;
};
