/**
 * Returns a string describing the effects of the slave putting on shows only
 * To see full effects, see farmyardShows.js
 * @param {App.Entity.SlaveState} slave
 * @returns {string}
 */
App.Facilities.Farmyard.putOnShows = function(slave) {
	const
		{he, him, his, hers, He, His} = getPronouns(slave),
		incomeStats = getSlaveStatisticData(slave, V.facility.farmyard),
		arcology = V.arcologies[0],
		_beautiful = beautiful(slave),
		_pretty = pretty(slave),

		heavyMods = SlaveStatsChecker.modScore(slave).total > 20;

	let r = [];

	incomeStats.income += App.Facilities.Farmyard.farmShowsIncome(slave);

	r.push(`${He} also puts on shows with animals this week.`);

	// Open FS Subsection

	if (arcology.FSSupremacist !== "unset") {
		if (isSuperiorRace(slave)) {
			if (V.seeBestiality) {
				r.push(`Society <span class="reputation dec">disapproves</span> of your allowing a member of the elite race to be degraded in such a fashion, and thus ${he} didn't earn as much.`);
			} else {
				r.push(`Since ${arcology.FSSupremacistRace} slaves are in fashion, ${he} attracts a little more attention than if ${he} wasn't ${arcology.FSSupremacistRace}.`);
			}
		} else {
			r.push(`Society doesn't disapprove of ${him} not being ${arcology.FSSupremacistRace}, but ${he} doesn't earn as much as ${he} would if ${he} was.`);
		}
	}

	if (arcology.FSSubjugationist !== "unset") {
		if (isInferiorRace(slave)) {
			if (V.seeBestiality) {
				r.push(`Society <span class="reputation inc">approves</span> of the degradation you submit your ${arcology.FSSubjugationistRace} slaves to, and so ${he} earns you a bit more.`);
			} else {
				r.push(`Fewer people want to go see a ${arcology.FSSubjugationistRace} slave put on a show, and so ${he} doesn't earn as much as ${he} otherwise could.`);
			}
		} else {
			r.push(`Society doesn't disapprove of ${him} not being ${arcology.FSSubjugationistRace}, but ${he} doesn't earn as much as ${he} would if ${he} was.`);
		}
	}

	if (arcology.FSRepopulationFocus !== "unset") {
		if (isPreg(slave)) {
			if (slave.eggType === "human") {
				r.push(`Society <span class="reputation inc">greatly approves</span> of your having pregnant slaves ${V.seeBestiality ? `have sex` : `put on shows`} with animals.`);
			} else {
				r.push(`Society is <span class="reputation dec">disgusted</span> by ${his} pregnancy when they realize that what it is in ${his} womb is not human.`);
			}
		}
	}

	if (arcology.FSRestart !== "unset") {
		if (isPreg(slave)) {
			if (isEliteBreeder(slave)) {
				if (slave.eggType === "human") {
					r.push(`Society is <span class="reputation dec">horrified</span> by the fact that you would dare defile a slave deemed fit for humanity's revival in such a manner, especially one that is carrying the future of the planet.`);
				} else {
					r.push(`Society is <span class="reputation dec">absolutely repulsed</span> by the fact that you would dare defile a slave deemed fit for humanity's revival in such a manner, especially when they learn that what is in ${his} womb is not even human.`);
				}
			} else {
				if (slave.eggType === "human") {
					r.push(`Society is <span class="reputation dec">extremely disgusted</span> by ${his} pregnancy and the fact that you would have ${him} ${V.seeBestiality ? `have sex` : `put on shows`} with animals while sporting a baby bump.`);
				} else {
					r.push(`Society is disgusted by ${his} pregnancy until they learn that what is in ${his} womb is not human.`);
				}
			}
		} else {
			if (V.seeBestiality && isEliteBreeder(slave)) {
				r.push(`Society is <span class="reputation dec">heavily disapproving</span> of the fact that you would dare defile a slave deemed fit for humanity's revival in such a manner.`);
			}
		}
	}

	if (arcology.FSGenderRadicalist !== "unset") {
		if (slave.dick > 0) {
			r.push(`${His} patrons <span class="reputation inc">approve</span> of the fact that ${he} has a dick.`);
		} else {
			r.push(`${His} patrons <span class="reputation dec">are disappointed</span> that ${he} doesn't have a dick.`);
		}
	}

	if (arcology.FSGenderFundamentalist !== "unset") {
		if (isPreg(slave) || setup.fakeBellies.includes(slave.bellyAccessory)) {
			r.push(`${His} viewers <span class="reputation inc">approve</span> of the fact that ${he} is sporting a baby bump${setup.fakeBellies.includes(slave.bellyAccessory) ? `, even though ${hers} isn't real` : ``}.`);
		} else {
			r.push(`${His} viewers <span class="reputation dec">are disappointed</span> that ${he} isn't pregnant.`);
		}
	}

	if (arcology.FSPaternalist !== "unset") {
		if (V.seeBestiality) {
			if (V.farmyardBreeding) {
				if (V.farmyardRestraints) {
					r.push(`Your citizens are <span class="reputation dec">extremely disapproving</span> of the fact that you would allow your slaves to be treated as nothing more than a bound breeding toy for your animals.`);
				} else {
					r.push(`Your citizens are <span class="reputation dec">highly disapproving</span> of the fact that you would allow your slaves to be treated as nothing more than a breeding toy for your animals.`);
				}
			} else {
				if (V.farmyardRestraints) {
					r.push(`Your citizens are <span class="reputation dec">very disapproving</span> of the fact that you would allow your slaves to be treated as nothing more than a bound toy for your animals.`);
				} else {
					r.push(`Your citizens are <span class="reputation dec">disapproving</span> of the fact that you would allow your slaves to be treated as nothing more than a toy for your animals.`);
				}
			}
		} else {
			// TODO:
		}
	}

	if (arcology.FSDegradationist !== "unset") {
		if (V.seeBestiality) {
			if (V.farmyardBreeding) {
				if (V.farmyardRestraints) {
					r.push(`Your citizens are <span class="reputation dec">extremely approving</span> of the fact that you would allow your slaves to be treated as nothing more than a bound breeding toy for your animals.`);
				} else {
					r.push(`Your citizens are <span class="reputation dec">highly approving</span> of the fact that you would allow your slaves to be treated as nothing more than a breeding toy for your animals.`);
				}
			} else {
				if (V.farmyardRestraints) {
					r.push(`Your citizens are <span class="reputation dec">very approving</span> of the fact that you would allow your slaves to be treated as nothing more than a bound toy for your animals.`);
				} else {
					r.push(`Your citizens are <span class="reputation dec">approving</span> of the fact that you would allow your slaves to be treated as nothing more than a toy for your animals.`);
				}
			}
		} else {
			// TODO:
		}
	}

	if (arcology.FSBodyPurist !== "unset") {
		if (SlaveStatsChecker.isModded(slave)) {
			r.push(`The members of the audience <span class="reputation dec">disapprove</span> that you would use a slave with ${heavyMods ? `such heavy` : ``} modifications to put on shows.`);
		}
	}

	if (arcology.FSTransformationFetishist !== "unset") {
		if (SlaveStatsChecker.isModded(slave)) {
			r.push(`The members of the audience <span class="reputation inc">approve</span> that you would use a slave with ${heavyMods ? `such heavy` : ``} modifications to put on shows.`);
		}
	}

	if (arcology.FSYouthPreferentialist !== "unset") {
		if (isYoung(slave)) {
			r.push(`${arcology.name}'s citizens <span class="reputation dec">disapprove</span> of your using such old slaves to put on shows.`);
		} else {
			r.push(`${arcology.name}'s citizens <span class="reputation inc">approve</span> of your using young slaves to put on shows.`);
		}
	}

	if (arcology.FSMaturityPreferentialist !== "unset") {
		if (isYoung(slave)) {
			r.push(`${arcology.name}'s citizens <span class="reputation inc">approve</span> of your using mature slaves to put on shows.`);
		} else {
			r.push(`${arcology.name}'s citizens <span class="reputation dec">disapprove</span> of your using such young slaves to put on shows.`);
		}
	}

	if (arcology.FSSlimnessEnthusiast !== "unset") {
		if (slimLawPass(slave)) {
			r.push(`${His} slim body <span class="reputation inc">attracts a wider audience.</span>`);
		} else {
			r.push(`Society finds your using a slave with such a flabby body <span class="reputation dec">disgusting.</span>`);
		}
	}

	// FIXME: marked for possible rewrite
	if (arcology.FSAssetExpansionist !== "unset") {
		if (isStacked(slave)) {
			r.push(`Society <span class="reputation inc">approves</span> of the fact that you respect their ideals in using a slave with larger assets.`);
		}
	}

	if (arcology.FSPastoralist !== "unset") {
		if (slave.boobs >= 1000) {
			r.push(`The fact that ${slave.slaveName} has such large udders <span class="reputation inc">pleases your citizens.</span>`);
		}

		if (slave.lactation > 0) {
			r.push(`Your citizens ${slave.boobs >= 1000 ? `also ` : ``}<span class="reputation inc">approve</span> of the fact that ${he} is visibly lactating.`);
		}
	}

	// FIXME: marked for review
	if (arcology.FSPhysicalIdealist !== "unset") {
		if (genderLawPass(slave)) {
			r.push(`The fact that ${slave.slaveName} has what is considered the ideal form also <span class="reputation inc">helps ${him} attract attention,</span> and so ${he} earns a bit more.`);
		} else {
			r.push(`${His} form isn't exactly what ${arcology.name}'s citizens consider ideal, and so ${he} doesn't <span class="reputation dec">earn as much.</span>`);
		}
	}

	// FIXME: marked for rewrite
	if (arcology.FSHedonisticDecadence !== "unset") {
		if (slave.weight > 10) {
			r.push(`Since ${slave.slaveName} is large enough for ${arcology.name}'s citizens, ${he} earns slightly more.`);
		} else {
			r.push(`${He} doesn't earn quite as much ${he} would have if ${he} was a bit larger in size.`);
		}
	}

	if (arcology.FSChattelReligionist !== "unset") {
		if (slave.devotion <= 20) {
			// TODO: write this
		} else {
			// TODO: write this
		}
	}

	if (arcology.FSPetiteAdmiration !== "unset") {
		if (heightPass(slave)) {
			r.push(`The fact that you are using such small slaves <span class="reputation inc">pleases your citizens.</span>`);
		} else {
			r.push(`The fact that you are using such small slaves <span class="reputation dec">displeases your citizens.</span>`);
		}
	}

	if (arcology.FSStatuesqueGlorification !== "unset") {
		if (heightPass(slave)) {
			r.push(`Your citizens <span class="reputation inc">approve</span> of your using such statuesque slaves for putting on shows.`);
		} else {
			r.push(`Your citizens <span class="reputation dec">disapprove</span> of your not using taller slaves for putting on shows.`);
		}
	}

	if (arcology.FSRomanRevivalist !== "unset") {
		// TODO:
	}

	if (arcology.FSAztecRevivalist !== "unset") {
		// TODO:
	}

	if (arcology.FSEgyptianRevivalist !== "unset") {
		// TODO:
	}

	if (arcology.FSEdoRevivalist !== "unset") {
		// TODO:
	}

	if (arcology.FSArabianRevivalist !== "unset") {
		// TODO:
	}

	if (arcology.FSChineseRevivalist !== "unset") {
		// TODO:
	}

	// Close FS Subsection

	if (setup.entertainmentCareers.includes(slave.career)) {
		r.push(`${He} has experience with putting on shows from ${his} life before ${he} was a slave, making ${him} more effective at putting on shows.`);
	}

	// FIXME: can slaves' careers overlap categories?
	if (setup.farmerCareers.includes(slave.career)) {
		r.push(`${He} ${setup.entertainmentCareers.includes(slave.career) ? `also` : ``} has experience in working with animals from ${his} life before ${he} was a slave, making ${him} more effective at putting on shows.`);
	}

	if (slave.prestige === 1) {
		r.push(`Because some of your citizens already know of ${him}, ${he} earns more.`);
	} else if (slave.prestige === 2) {
		r.push(`Because a lot of your citizens already know of ${him}, ${he} earns quite a bit more.`);
	} else if (slave.prestige === 3) {
		r.push(`Because ${he} is so famous, ${he} earns a lot more then ${he} would otherwise.`);
	}

	if (slave.porn.prestige === 1) {
		r.push(`${He} earns a bit more because some of your citizens already know ${him} from porn.`);
	} else if (slave.porn.prestige === 2) {
		r.push(`${He} earns quite a bit more because a lot of your citizens already know ${him} from porn.`);
	} else if (slave.porn.prestige === 3) {
		r.push(`${He} earns a lot more because ${he} is so famous from porn.`);
	}

	if (slave.health.condition > 50) {
		r.push(`${He} is in such excellent health that ${he} is able to put on longer and more energetic shows, earning you more.`);
	} else if (slave.health.condition < -20) {
		r.push(`${His} poor health negatively affects ${his} ability to put on good shows, cutting into your profits.`);
	}

	// TODO: add checks for family and relationships

	if (slave.face > 40) {
		r.push(`${He} is so ${_beautiful} that ${his} audience is willing to pay more to watch ${him} put on shows.`);
	} else if (slave.face > 10) {
		r.push(`${He} is so ${_pretty} that ${his} audience is willing to pay more to watch ${him} put on shows.`);
	} else if (slave.face < -10) {
		r.push(`${His} audience isn't willing to pay as much because of how unattractive ${his} face is.`);
	} else if (slave.face < -40) {
		r.push(`${His} audience isn't willing to pay as much because of how hard ${his} face is to look at.`);
	}

	// TODO: incorporate seeBestiality, breeding, and restraints
	if (slave.devotion > 50) {
		if (slave.trust > 50) {
			r.push(`${He} is so devoted that ${he} works ${his} hardest to make ${his} show a good one.`);
		} else if (slave.trust < -50) {
			r.push(`${He} is both devoted to you and terrified of you, so ${he} tries ${his} best to make ${his} show a good one.`);
		}
	} else if (slave.devotion < -50) {
		if (slave.trust > 50) {
			r.push(`${slave.slaveName} purposefully does the bare minimum ${he} can get away with to spite you.`);
		} else if (slave.trust < -50) {
			r.push(`${slave.slaveName} refuses to do anything without punishment, which is evident from ${his} meager earnings.`);
		}
	}

	// FIXME: marked for rewrite
	if (slave.weight > 30) {
		if (arcology.FSHedonisticDecadence === "unset") {
			r.push(`Your citizens are not willing to pay as much to see such a fat slave put on shows, so ${he} loses some income.`);
		}
	} else if (slave.weight < -30) {
		r.push(`Your citizens don't like watching such a sickly-looking slaves put on shows, so ${he} loses some income.`);
	}

	if (slave.muscles > 30) {
		// TODO: write this - do we want something for muscles?
	} else if (slave.muscles < -30) {
		r.push(`${slave.slaveName} is so weak that ${he} cannot even properly handle the animals ${he}'s assigned to ${V.seeBestiality ? `fuck` : `work with`}, and isn't able to put on any sort of meaningful show.`);
	}

	if (!canSeePerfectly(slave)) {
		r.push(`${His} ${!canSee(slave) ? `blindness makes it impossible` : `nearsightedness makes it harder`} for ${him} to see what ${he}'s doing, affecting ${his} ability to put on a good show.`);
	}

	if (slave.hears < 0) {
		r.push(`${His} ${slave.hears < -1 ? `lack of` : `poor`} hearing makes it difficult for ${him} to hear what ${his} audience wants from ${him}, which really affects ${his} earnings.`);
	}

	// FIXME: marked for rewrite
	if (isPreg(slave)) {
		r.push(`${His}${slave.bellyPreg > 100000 ? ` advanced` : ``} pregnancy makes it more difficult for him to effectively put on a good show.`);
	}

	if (slave.health.tired > 60) {
		r.push(`${He} is so tired that the energy in ${his} shows is basically nonexistent, affecting ${his} profits.`);
	}

	if (slave.intelligence > 50) {
		r.push(`Because ${he} is so intelligent, ${he} is able to tailor ${his} shows to ${his} audience, helping ${him} bring in more in profits.`);
	} else if (slave.intelligence < -50) {
		r.push(`${He} is so slow that all ${he} can really do is just ${V.seeBestiality ? `lie there and take it` : `put on the most basic of moves`}, which your audience finds dull and uninteresting.`);
	}

	if (slave.energy > 95) {
		r.push(`The fact that ${he} is a nymphomaniac helps ${him} to go for longer, allowing ${him} to really put on an amazing show.`);
	} else if (slave.energy > 80) {
		r.push(`The fact that ${his} sex drive is so powerful helps ${him} to really put on good shows.`);
	} else if (slave.energy > 60) {
		r.push(`The fact that ${his} sex drive is so good helps ${him} to put on good shows.`);
	} else if (slave.energy > 40) {
		r.push(`${His} average sex drive allows ${him} to put on a decent show.`);
	} else if (slave.energy > 20) {
		r.push(`The fact that ${his} sex drive is so poor affects ${his} performance.`);
	} else {
		r.push(`The fact that ${his} sex drive is nonexistent really hinders ${his} ability to put on a decent show.`);
	}

	// TODO: add more to the fetishes and flaws / quirks
	switch (slave.fetish) {
		case "submissive":
			if (V.seeBestiality) {
				if (slave.fetishKnown) {
					r.push(`${He} is so submissive that ${he} willingly accepts ${his} position as an animal's fucktoy and <span class="reputation inc">is able to put on a decent show</span>.`);
				} else {
					r.push(`${S.HeadGirl ? `${S.HeadGirl.slaveName} notices` : `You notice`} that ${slave.slaveName} seems to have really taken to ${his} position as a fucktoy for animals. <span class="lightcoral">${He}'s a submissive!</span>`);
				}
			} else {
				if (slave.fetishKnown) {
					r.push(`Being a submissive, ${he} <span class="reputation dec">doesn't have the confidence required</span> to really put on a good show.`);
				} else {
					r.push(`${slave.slaveName} doesn't seem to have the type of fortitude needed to put on a show, and after some probing, you discover why - it turns out <span class="lightcoral">${he}'s a submissive!</span>`);
				}
			}
			break;

		case "humiliation":
			if (V.seeBestiality) {
				if (slave.fetishKnown) {
					r.push(`${slave.slaveName} uses the most of this humiliating experience to really put on a show, to <span class="reputation inc">the approval of ${his} audience</span>.`);
				} else {
					// TODO:
				}
			} else {
				// TODO: not sure about this one
			}
			break;

		default:
			break;
	}

	switch (slave.behavioralFlaw) {
		case "arrogant":
			r.push(`Because ${he} is so arrogant, ${he} tries ${his} hardest to avoid ${V.seeBestiality ? `fucking animals` : `putting on shows`}, <span class="cash dec">which affects ${his} profits</span> and <span class="reputation dec">your reputation.</span>`);
			break;

		case "devout":
			r.push(`${He} often prays ${V.seeBestiality ? ` while getting fucked by animals` : ` during ${his} shows`}, which your citizens <span class="reputation dec">find off-putting.</span>`);
			break;

		default:
			break;
	}

	switch (slave.behavioralQuirk) {
		case "sinful":
			r.push(`${He} relishes in ${his} ability to do something so sinful and depraved, and <span class="reputation inc">really puts on a show.</span>`);
			break;

		default:
			break;
	}

	switch (slave.sexualFlaw) {
		case "shamefast":
			r.push(`${His} crippling shamefastness <span class="reputation dec">limits ${his} ability</span> to put on a decent show.`);
			break;

		default:
			break;
	}

	switch (slave.sexualQuirk) {
		case "perverted":
			r.push(`${His} shows are a <span class="reputation inc">real spectacle,</span> since ${he} is so perverted that ${he} is willing to go far beyond the bare minimum.`);
			break;

		default:
			break;
	}

	return r.join(' ');
};
