App.EventHandlers = function() {
	/**
	 * @param {SugarCubeLib.SaveObject} save
	 */
	function onLoad(save) {
		const v = save.state.history[0].variables;
		if (v.releaseID === 2000) {
			v.releaseID = 1100;
		}
		if (v.releaseID > App.Version.release) {
			console.error("Save game version problem. Loaded : " + v.releaseID + ", above expected:" + App.Version.release); // eslint-disable-line no-console
			throw new Error("The save you're attempting to load was created with the game version newer than one you are running. Please download the latest game version.");
		}
		// updating settings only for the same releaseID, otherwise user will run
		// backwards compatibility and we update settings from there
		if (v.releaseID === App.Version.release) {
			App.UI.SlaveSummary.settingsChanged(v);
		}
	}

	/**
	 * @param {SugarCubeLib.SaveObject} save
	 */
	function onSave(save) {
	}

	function storyReady() {
		App.UI.Theme.init();
		App.UI.Hotkeys.init();
	}

	function optionsChanged() {
		App.UI.SlaveSummary.settingsChanged();
	}

	return {
		onLoad: onLoad,
		onSave: onSave,
		storyReady: storyReady,
		optionsChanged: optionsChanged
	};
}();
