/**
 * @param {App.Entity.SlaveState} slave
 * @returns {string}
 */
App.Desc.footwear = function(slave) {
	const r = [];
	const {
		he, him, his, He
	} = getPronouns(slave);
	if (hasAnyLegs(slave)) {
		switch (slave.clothes) {
			case "a hijab and blouse":
			case "conservative clothing":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of comfortable sandals.`);
						break;
					case "boots":
						r.push(`a pair of nice leather boots.`);
						break;
					case "heels":
						r.push(`a pair of comfortable heels.`);
						break;
					case "pumps":
						r.push(`a pair of comfortable pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of daringly high heels.`);
						break;
					case "platform shoes":
						r.push(`a pair of comfortable platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of comfortable platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of daringly high heels with equally thrilling platforms.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "chains":
				switch (slave.shoes) {
					case "flats":
						r.push(`buckled sandals that incorporate shackles at each ankle.`);
						break;
					case "boots":
						r.push(`utility boots with a shackle at each ankle.`);
						break;
					case "heels":
						r.push(`sturdy heels, secured by metal buckles, with shackles at each ankle.`);
						break;
					case "pumps":
						r.push(`stout pumps, secured with a tight chain that winds around each ankle.`);
						break;
					case "extreme heels":
						r.push(`painfully high metal heels, secured by buckles, with shackles at each ankle.`);
						break;
					case "platform shoes":
						r.push(`metal platform shoes that incorporate shackles at each ankle.`);
						break;
					case "platform heels":
						r.push(`sturdy platform heels, secured by metal buckles, with shackles at each ankle.`);
						break;
					case "extreme platform heels":
						r.push(`painfully high metal heels with terrifyingly tall platforms, secured by buckles and shackled to each ankle.`);
						break;
					default:
						r.push(`nothing.`);
				}
				break;
			case "Western clothing":
				switch (slave.shoes) {
					case "flats":
						r.push(`soft leather moccasins.`);
						break;
					case "boots":
						r.push(`tooled leather cowboy boots.`);
						break;
					case "heels":
						r.push(`high-heeled cowboy boots.`);
						break;
					case "pumps":
						r.push(`pump-shaped cowboy boots.`);
						break;
					case "extreme heels":
						r.push(`thigh-high tooled leather cowboy boots with dangerously high heels.`);
						break;
					case "platform shoes":
						r.push(`platformed cowboy boots.`);
						break;
					case "platform heels":
						r.push(`high-heeled cowboy boots with a platform base.`);
						break;
					case "extreme platform heels":
						r.push(`tooled leather cowboy boots with ridiculously tall platform heels that force ${him} to walk bow-legged.`);
						break;
					default:
						r.push(`bare cowpoke feet.`);
				}
				break;
			case "overalls":
				switch (slave.shoes) {
					case "flats":
						r.push(`aside from a pair of mudproof sneakers.`);
						break;
					case "boots":
						r.push(`aside from a pair of utilitarian leather boots.`);
						break;
					case "heels":
						r.push(`aside from a pair of simple leather heels.`);
						break;
					case "pumps":
						r.push(`aside from a pair of mudproof pumps.`);
						break;
					case "extreme heels":
						r.push(`aside from a pair of extremely tall leather heels.`);
						break;
					case "platform shoes":
						r.push(`aside from a pair of durable platform shoes.`);
						break;
					case "platform heels":
						r.push(`aside from a pair of sturdy platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`aside from a pair of extremely tall platform heels.`);
						break;
					default:
						r.push(`down to ${his} feet.`);
				}

				break;
			case "body oil":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of trainers ready for a workout.`);
						break;
					case "boots":
						r.push(`thigh-high stripper boots, since they're ${his} only way to dress up.`);
						break;
					case "heels":
						r.push(`heeled trainers, to look athletic and sexy at the same time.`);
						break;
					case "pumps":
						r.push(`pump-shaped trainers, for a slutty athletic look.`);
						break;
					case "extreme heels":
						r.push(`ankle-supporting high heels to force ${him} as high as possible without damage.`);
						break;
					case "platform shoes":
						r.push(`a pair of trainers with a sturdy platform fit for a workout.`);
						break;
					case "platform heels":
						r.push(`ankle-supporting platform heels to protect ${him} from sprains.`);
						break;
					case "extreme platform heels":
						r.push(`extremely tall, but ankle-supporting, platform heels to protect ${him} from sprains.`);
						break;
					default:
						r.push(`nothing but a fine layer of oil on the tops of ${his} bare feet.`);
				}
				break;
			case "a toga":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of leather sandals with a mirror image of the words "FUCK ME" embossed into the soles, so that if ${he} walks on sand the message will be visible in ${his} footprints.`);
						break;
					case "boots":
						r.push(`high leather boot sandals that remain comfortable`);
						if (canWalk(slave)) {
							r.push(`after walking`);
							if (V.showInches === 2) {
								r.push(`25 miles`);
							} else {
								r.push(`40 kilometers`);
							}
							r.push(`in one`);
						} else {
							r.push(`all throughout the`);
						}
						r.push(`day.`);
						break;
					case "heels":
						r.push(`heeled sandals with a mirror image of the words "POUND ME" embossed into the soles, so that if ${he} walks on sand the message will be visible in ${his} footprints.`);
						break;
					case "pumps":
						r.push(`pump-like sandals with a mirror image of the words "BREED ME" embossed into the soles, so that if ${he} walks on sand the message will be visible in ${his} footprints.`);
						break;
					case "extreme heels":
						r.push(`extremely tall heels with a mirror image of the words "FUCK ME" embossed into the soles, so that if ${he} walks on sand the message will be visible in ${his} footprints.`);
						break;
					case "platform shoes":
						r.push(`a pair of platform sandals with a mirror image of the words "MOUNT ME" embossed into the soles, so that if ${he} walks on sand the message will be visible in ${his} footprints.`);
						break;
					case "platform heels":
						r.push(`platform heels with a mirror image of the words "FUCK ME" embossed into the soles, so that if ${he} walks on sand the message will be visible in ${his} footprints.`);
						break;
					case "extreme platform heels":
						r.push(`extremely tall platform heels with a penis embossed into the soles and a pair of lips in the heels, so that if ${he} walks on sand, oral sex will follow in ${his} footprints.`);
						break;
					default:
						r.push(`bare feet.`);
				}
				break;
			case "a huipil":
				switch (slave.shoes) {
					case "flats":
						r.push(`little leather sandals.`);
						break;
					case "boots":
						r.push(`high leather boots with thin rope laces and wooden heels.`);
						break;
					case "heels":
						r.push(`beautiful wood and leather stilettos with an ornamented heel.`);
						break;
					case "pumps":
						r.push(`beautiful wood and leather pumps with an ornamented heel.`);
						break;
					case "extreme heels":
						r.push(`high wooden heels with leather straps.`);
						break;
					case "platform shoes":
						r.push(`simple wood and leather platform shoes.`);
						break;
					case "platform heels":
						r.push(`beautiful wood and leather stilettos with an ornamented platform and heel.`);
						break;
					case "extreme platform heels":
						r.push(`towering ornamented wood and leather platform heels.`);
						break;
					default:
						r.push(`bare feet with a small ankle chain.`);
				}
				break;
			case "a skimpy loincloth":
				switch (slave.shoes) {
					case "flats":
						r.push(`barbarous leather sandals.`);
						break;
					case "boots":
						r.push(`barbarous leather boots with thin leather laces and bone heels.`);
						break;
					case "heels":
						r.push(`barbarous leather stilettos with an ornamented bone heel.`);
						break;
					case "pumps":
						r.push(`barbarous leather pumps with an ornamented bone heel.`);
						break;
					case "extreme heels":
						r.push(`barbarous high bone heels with leather straps.`);
						break;
					case "platform shoes":
						r.push(`barbarous leather sandals with a solid bone platform.`);
						break;
					case "platform heels":
						r.push(`barbarous leather stilettos with an ornamented bone platform and heel.`);
						break;
					case "extreme platform heels":
						r.push(`arbarous high bone platform heels with leather straps.`);
						break;
					default:
						r.push(`bare feet.`);
				}
				break;
			case "a slutty qipao":
				switch (slave.shoes) {
					case "flats":
						r.push(`little silk slippers.`);
						break;
					case "boots":
						r.push(`elegant leather boots.`);
						break;
					case "heels":
						r.push(`brightly colored heels.`);
						break;
					case "pumps":
						r.push(`brightly colored pumps.`);
						break;
					case "extreme heels":
						r.push(`extreme heels that mimic bound feet.`);
						break;
					case "platform shoes":
						r.push(`brightly colored platform shoes.`);
						break;
					case "platform heels":
						r.push(`small platform heels that mimic bound feet.`);
						break;
					case "extreme platform heels":
						r.push(`extreme platform heels that tightly bind ${his} feet.`);
						break;
					default:
						r.push(`bare stockinged feet.`);
				}
				break;
			case "uncomfortable straps":
				r.push(`straps that`);
				switch (slave.shoes) {
					case "flats":
						r.push(`run down ${his} legs to end in sandals that incorporate shackles at each ankle.`);
						break;
					case "boots":
						r.push(`run down ${his} legs to end in utility boots that incorporate shackles at each ankle.`);
						break;
					case "heels":
						r.push(`run down ${his} legs to end in high leather heels that incorporate shackles at each ankle.`);
						break;
					case "pumps":
						r.push(`run down ${his} legs to end in high leather pumps.`);
						break;
					case "extreme heels":
						r.push(`end in high leather heels that force ${him} to stand almost on tiptoe.`);
						break;
					case "platform shoes":
						r.push(`run down ${his} legs to end in platform shoes that incorporate shackles at each ankle.`);
						break;
					case "platform heels":
						r.push(`run down ${his} legs to end in platform heels that incorporate shackles at each ankle.`);
						break;
					case "extreme platform heels":
						r.push(`end in high platform heels that force ${him} to balance precariously on tiptoe.`);
						break;
					default:
						r.push(`end in shackles at each heel, leaving ${his} feet bare.`);
				}
				break;
			case "shibari ropes":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of rope sandals.`);
						break;
					case "boots":
						r.push(`a pair of canvas boots attached to the rest of ${his} ropes.`);
						break;
					case "heels":
						r.push(`a pair of rope sandal heels attached to the rest of ${his} ropes.`);
						break;
					case "pumps":
						r.push(`a pair of rope sandal pumps attached to the rest of ${his} ropes.`);
						break;
					case "extreme heels":
						r.push(`a pair of rope sandal heels that force ${him} to stand almost on tiptoe. They are attached to the rest of ${his} ropes.`);
						break;
					case "platform shoes":
						r.push(`a pair of rope platform sandals.`);
						break;
					case "platform heels":
						r.push(`a pair of rope platform sandal heels attached to the rest of ${his} ropes.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of rope platform sandal heels that force ${him} to stand on tiptoe. They are attached to the rest of ${his} ropes.`);
						break;
					default:
						r.push(`end at each ankle, leaving ${his} feet bare.`);
				}
				break;
			case "restrictive latex":
				r.push(`latex which`);
				switch (slave.shoes) {
					case "flats":
						r.push(`covers ${his} feet as well.`);
						break;
					case "boots":
						r.push(`ends in a pair of boots made from the same material.`);
						break;
					case "heels":
						r.push(`ends in a pair of high heels made from the same material.`);
						break;
					case "pumps":
						r.push(`ends in a pair of high pumps made from the same material.`);
						break;
					case "extreme heels":
						r.push(`ends in a pair of painfully high heels made from the same material, so tall ${he} must walk nearly on tiptoe, and shaped so that ${he} must stick ${his} ass out to stand.`);
						break;
					case "platform shoes":
						r.push(`ends in a pair of platforms made from the same material.`);
						break;
					case "platform heels":
						r.push(`ends in a pair of high platform heels made from the same material.`);
						break;
					case "extreme platform heels":
						r.push(`ends in a pair of painfully high platform heels made from the same material, so tall ${he} must walk on tiptoe and stick ${his} ass out to stand with any semblance of balance.`);
						break;
					default:
						r.push(`ends at the ankles, leaving ${his} feet bare.`);
				}
				break;
			case "a latex catsuit":
				switch (slave.shoes) {
					case "flats":
						r.push(`patent leather flats.`);
						break;
					case "boots":
						r.push(`laced thigh-high boots.`);
						break;
					case "heels":
						r.push(`patent leather heels.`);
						break;
					case "pumps":
						r.push(`patent leather pumps.`);
						break;
					case "extreme heels":
						r.push(`laced ballet boots that limit ${him} to small, dainty steps.`);
						break;
					case "platform shoes":
						r.push(`patent platform shoes.`);
						break;
					case "platform heels":
						r.push(`patent platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`patent high platform heels that limit ${him} to careful, dainty steps.`);
						break;
					default:
						r.push(`nothing at the moment, leaving ${him} free to show off ${his} smooth legs.`);
				}
				break;
			case "attractive lingerie":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of cute flats.`);
						break;
					case "boots":
						r.push(`a pair of cute little ankle boots.`);
						break;
					case "heels":
						r.push(`a pair of sexy heels in the same color.`);
						break;
					case "pumps":
						r.push(`a pair of sexy pumps in the same color.`);
						break;
					case "extreme heels":
						r.push(`a pair of high stripper heels in the same color.`);
						break;
					case "platform shoes":
						r.push(`a pair of cute platforms in the same color.`);
						break;
					case "platform heels":
						r.push(`a pair of sexy platform heels in the same color.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of high stripper platform heels in the same color, so tall that ${he} must stick ${his} ass and chest out to stand.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "kitty lingerie":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of cute flats.`);
						break;
					case "boots":
						r.push(`a pair of cute little ankle boots.`);
						break;
					case "heels":
						r.push(`a pair of sexy heels.`);
						break;
					case "pumps":
						r.push(`a pair of sexy pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of high stripper heels.`);
						break;
					case "platform shoes":
						r.push(`a pair of cute heart-shaped platforms.`);
						break;
					case "platform heels":
						r.push(`a pair of sexy heart-shaped heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of high stripper platform heels so tall that ${he} must stick ${his} ass out to stand.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "attractive lingerie for a pregnant woman":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of cute slippers.`);
						break;
					case "boots":
						r.push(`a pair of cute little ankle boots.`);
						break;
					case "heels":
						r.push(`a pair of sexy heels in the same color.`);
						break;
					case "pumps":
						r.push(`a pair of sexy pumps in the same color.`);
						break;
					case "extreme heels":
						r.push(`a pair of high stripper heels in the same color.`);
						break;
					case "platform shoes":
						r.push(`a pair of cute, but sturdy, platforms.`);
						break;
					case "platform heels":
						r.push(`a pair of sexy, yet sturdy, platform heels in the same color.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of high stripper platform heels so tall that ${he} must stick ${his} ass out to stand.`);
						if (slave.belly >= 10000) {
							r.push(`This has the lovely effect of forcing ${him} to straddle ${his} belly.`);
						}
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a maternity dress":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of comfortable sandals.`);
						break;
					case "boots":
						r.push(`a pair of nice leather boots.`);
						break;
					case "heels":
						r.push(`a pair of comfortable heels.`);
						break;
					case "pumps":
						r.push(`a pair of comfortable pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of daringly high heels.`);
						break;
					case "platform shoes":
						r.push(`a pair of comfortable platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of comfortable sturdy platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of daringly high platform heels`);
						if (slave.belly >= 10000) {
							r.push(`that add a sexy sway to ${his} gravid waddle.`);
						} else {
							r.push(`that force ${him} to move at with gravid waddle.`);
							break;
						}
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "stretch pants and a crop-top":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of comfortable sandals.`);
						break;
					case "boots":
						r.push(`a pair of slip on comfortable boots.`);
						break;
					case "heels":
						r.push(`a pair of comfortable heels.`);
						break;
					case "pumps":
						r.push(`a pair of comfortable pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of daringly high heels.`);
						break;
					case "platform shoes":
						r.push(`a pair of comfortable platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of comfortable platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of daringly high platform heels so tall that ${he} must stick ${his} ass out to stand.`);
						if (slave.weight > 95) {
							r.push(`This has the lovely effect of allowing ${his} gut to hang heavily from ${his} body.`);
						}
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a succubus outfit":
				switch (slave.shoes) {
					case "flats":
						r.push(`Grecian sandals.`);
						break;
					case "boots":
						r.push(`colored leather boots that come most of the way up ${his} thighs.`);
						break;
					case "heels":
						r.push(`colored stiletto heels.`);
						break;
					case "pumps":
						r.push(`colored stiletto pumps.`);
						break;
					case "extreme heels":
						r.push(`tall boots that make ${his} feet look like hooves.`);
						break;
					case "platform shoes":
						r.push(`shoes with hoof-like platforms.`);
						break;
					case "platform heels":
						r.push(`colored stiletto platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`towering platform heels that make ${his} feet look like hooves.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a fallen nuns habit":
				r.push(`latex which`);
				switch (slave.shoes) {
					case "flats":
						r.push(`covers ${his} feet as well.`);
						break;
					case "boots":
						r.push(`ends in a pair of boots made from the same material.`);
						break;
					case "heels":
						r.push(`ends in a pair of high heels made from the same material.`);
						break;
					case "pumps":
						r.push(`ends in a pair of high pumps made from the same material.`);
						break;
					case "extreme heels":
						r.push(`ends in a pair of painfully high heels made from the same material, so tall ${he} must walk nearly on tiptoe, and shaped so that ${he} must stick ${his} ass out to stand.`);
						break;
					case "platform shoes":
						r.push(`ends in a pair of platforms made from the same material.`);
						break;
					case "platform heels":
						r.push(`ends in a pair of high platform heels made from the same material.`);
						break;
					case "extreme platform heels":
						r.push(`ends in a pair of painfully high platform heels made from the same material, so tall ${he} must walk on tiptoe and stick ${his} ass out to stand with any semblance of balance.`);
						break;
					default:
						r.push(`ends at the ankles, leaving ${his} feet bare.`);
				}
				break;
			case "a chattel habit":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of gold sandals with thin straps that run up ${his} calves.`);
						break;
					case "boots":
						r.push(`white leather boots that run most of the way up ${his} thighs.`);
						break;
					case "heels":
						r.push(`a pair of gold heels secured by thin straps that run up ${his} calves.`);
						break;
					case "pumps":
						r.push(`a pair of gold pumps secured by thin straps that run up ${his} calves.`);
						break;
					case "extreme heels":
						r.push(`a pair of white leather stripper heels secured by thin golden straps that run up ${his} calves.`);
						break;
					case "platform shoes":
						r.push(`a pair of gold platform sandals with thin straps that run up ${his} calves.`);
						break;
					case "platform heels":
						r.push(`a pair of gold platform heels secured by thin straps that run up ${his} calves.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of white leather platform stripper heels secured by thin golden straps that run up ${his} calves.`);
						break;
					default:
						r.push(`nothing for ${his} feet.`);
				}
				break;
			case "a penitent nuns habit":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of scratchy rope sandals.`);
						break;
					case "boots":
						r.push(`a pair of ill-fitting old boots.`);
						break;
					case "heels":
						r.push(`a pair of utilitarian heels.`);
						break;
					case "pumps":
						r.push(`a pair of utilitarian pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of heels designed as religious torment.`);
						break;
					case "platform shoes":
						r.push(`a pair of weighted platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of utilitarian platform heels with built-in weights.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of tortuously high platform heels complete with built-in weights.`);
						break;
					default:
						r.push(`feet left bare on the cold ground.`);
				}
				break;
			case "a string bikini":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of thong sandals.`);
						break;
					case "boots":
						r.push(`a pair of stripper boots with turned-down tops.`);
						break;
					case "heels":
						r.push(`a pair of cheap stripper heels.`);
						break;
					case "pumps":
						r.push(`a pair of pole dancing pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of stripper heels so tall ${he} has to walk with ${his} ass sticking out.`);
						break;
					case "platform shoes":
						r.push(`a pair of pole dancing platforms.`);
						break;
					case "platform heels":
						r.push(`a pair of cheap stripper platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of platform heels so tall ${he} has to walk with ${his} ass and chest sticking out.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a scalemail bikini":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of leather sandals.`);
						break;
					case "boots":
						r.push(`a pair of steel-plated leather boots.`);
						break;
					case "heels":
						r.push(`a pair of steel-plated leather heels.`);
						break;
					case "pumps":
						r.push(`a pair of steel-plated leather pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of leather heels so tall ${he} has to walk with ${his} ass sticking out.`);
						break;
					case "platform shoes":
						r.push(`a pair of steel-plated platform boots.`);
						break;
					case "platform heels":
						r.push(`a pair of steel-plated leather platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of platform heels so tall ${he} has to walk with ${his} ass and chest sticking out.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "striped panties":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of flat trainers.`);
						break;
					case "boots":
						r.push(`a pair of high-top trainers.`);
						break;
					case "heels":
						r.push(`a pair of heeled trainers.`);
						break;
					case "pumps":
						r.push(`a pair of pump trainers.`);
						break;
					case "extreme heels":
						r.push(`a pair of heeled trainers so tall ${he} has to walk rather bouncily.`);
						break;
					case "platform shoes":
						r.push(`a pair of platform trainers.`);
						break;
					case "platform heels":
						r.push(`a pair of heeled platform trainers.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of heeled platform trainers so tall ${he} has to walk with a sultry sway.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a cheerleader outfit":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of flat trainers.`);
						break;
					case "boots":
						r.push(`a pair of high-top trainers.`);
						break;
					case "heels":
						r.push(`a pair of heeled trainers.`);
						break;
					case "pumps":
						r.push(`a pair of pump trainers.`);
						break;
					case "extreme heels":
						r.push(`a pair of heeled trainers so tall ${he} has to walk rather bouncily.`);
						break;
					case "platform shoes":
						r.push(`a pair of platform trainers.`);
						break;
					case "platform heels":
						r.push(`a pair of heeled platform trainers.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of heeled platform trainers so tall ${he} has to give everyone a view up ${his} skirt trying to balance.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "clubslut netting":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of surprisingly sturdy flats for dancing in a crowd.`);
						break;
					case "boots":
						r.push(`a pair of tall, comfortable leather boots to dance in.`);
						break;
					case "heels":
						r.push(`a pair of comfortable heels to dance in.`);
						break;
					case "pumps":
						r.push(`a pair of comfortable pumps to dance in.`);
						break;
					case "extreme heels":
						r.push(`a pair of stripper heels so tall ${he} has to walk rather bouncily.`);
						break;
					case "platform shoes":
						r.push(`a pair of solid platform shoes fit for the disco floor.`);
						break;
					case "platform heels":
						r.push(`a pair of surprisingly sturdy platform heels to dominate the disco floor.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of daringly tall disco heels that make ${him} stand out on the dance floor.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "cutoffs and a t-shirt":
				switch (slave.shoes) {
					case "flats":
						r.push(`girly sneakers.`);
						break;
					case "boots":
						r.push(`girly tasseled boots.`);
						break;
					case "heels":
						r.push(`high heeled sneakers.`);
						break;
					case "pumps":
						r.push(`girly pump sneakers.`);
						break;
					case "extreme heels":
						r.push(`high heeled sneakers so high ${his} butthole is at perfect dick height.`);
						break;
					case "platform shoes":
						r.push(`girly platform shoes.`);
						break;
					case "platform heels":
						r.push(`girly platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`high heeled platform shoes so high ${his} butthole is at perfect dick height.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "spats and a tank top":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of flat sneakers.`);
						break;
					case "boots":
						r.push(`a pair of high-top trainers.`);
						break;
					case "heels":
						r.push(`a pair of heeled trainers.`);
						break;
					case "pumps":
						r.push(`a pair of athletic pump trainers.`);
						break;
					case "extreme heels":
						r.push(`a pair of heeled trainers so tall ${he} has a lot of trouble running.`);
						break;
					case "platform shoes":
						r.push(`a pair of trainers with a sturdy platform fit for a jog.`);
						break;
					case "platform heels":
						r.push(`a pair of heeled platform trainers that are sure to complicate a workout.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of heeled platform trainers so tall ${he} gets a workout just trying to walk.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a slave gown":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of fashionable slingback sandals.`);
						break;
					case "boots":
						r.push(`elegant worked leather boots.`);
						break;
					case "heels":
						r.push(`kitten heels.`);
						break;
					case "pumps":
						r.push(`sleek pumps.`);
						break;
					case "extreme heels":
						r.push(`daring spike heels so high ${his} butt is at dick height.`);
						break;
					case "platform shoes":
						r.push(`stylish platform shoes.`);
						break;
					case "platform heels":
						r.push(`elegant platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`elegant platform heels so high ${his} butt is at dick height.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "slutty business attire":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of kitten heeled flats.`);
						break;
					case "boots":
						r.push(`a pair of shiny leather heeled boots.`);
						break;
					case "heels":
						r.push(`a pair of slim fuck-me heels.`);
						break;
					case "pumps":
						r.push(`a pair of fuck-me pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of spike slingback heels so extreme ${he} has to walk with extreme care.`);
						break;
					case "platform shoes":
						r.push(`a pair of shiny leather platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of slim fuck-me platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of platform heels so extreme ${he} has to walk with an exaggerated sway in ${his} step.`);
						break;
					default:
						r.push(`comically bare feet.`);
				}
				break;
			case "nice business attire":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of kitten heeled flats.`);
						break;
					case "boots":
						r.push(`a pair of heeled boots, polished to a mirror shine.`);
						break;
					case "heels":
						r.push(`a pair of spike boardroom heels.`);
						break;
					case "pumps":
						r.push(`a pair of spike boardroom pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of spike boardroom heels so extreme ${he} has to concentrate just to stand.`);
						break;
					case "platform shoes":
						r.push(`a pair of polished leather platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of polished leather platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of polished leather platform heels so extreme ${he} has to concentrate just to stand.`);
						break;
					default:
						r.push(`ridiculously bare stockinged feet.`);
				}
				break;
			case "a ball gown":
				switch (slave.shoes) {
					case "flats":
						r.push(`a delicate pair of dancing slippers.`);
						break;
					case "boots":
						r.push(`a dainty pair of heeled booties.`);
						break;
					case "heels":
						r.push(`an ornate pair of stiletto heels.`);
						break;
					case "pumps":
						r.push(`an ornate pair of stiletto pumps.`);
						break;
					case "extreme heels":
						r.push(`an ornate pair of stiletto heels so extreme ${he} has to concentrate just to stand.`);
						break;
					case "platform shoes":
						r.push(`a delicate pair of platform shoes.`);
						break;
					case "platform heels":
						r.push(`an ornate pair of platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`an ornate pair of platform heels so extreme ${he} has to concentrate just to stand.`);
						break;
					default:
						r.push(`ridiculously bare stockinged feet.`);
				}
				break;
			case "a halter top dress":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of flat shoes with decorative bows.`);
						break;
					case "boots":
						r.push(`tights and a flashy pair of evening boots.`);
						break;
					case "heels":
						r.push(`an elegant pair of stiletto heels.`);
						break;
					case "pumps":
						r.push(`an elegant pair of stiletto pumps.`);
						break;
					case "extreme heels":
						r.push(`tights and a pair of stiletto heels so extreme ${he} has to concentrate just to stand.`);
						break;
					case "platform shoes":
						r.push(`a pair of platform shoes with decorative bows.`);
						break;
					case "platform heels":
						r.push(`an elegant pair of platform heels complete with stiletto.`);
						break;
					case "extreme platform heels":
						r.push(`a narrow pair of platform heels so extreme ${he} has to concentrate just to stand.`);
						break;
					default:
						r.push(`with ${his} ridiculously bare feet in tights.`);
				}
				break;
			case "a mini dress":
				switch (slave.shoes) {
					case "flats":
						r.push(`suede flats.`);
						break;
					case "boots":
						r.push(`suede thigh-high boots.`);
						break;
					case "heels":
						r.push(`suede ankle strap heels.`);
						break;
					case "pumps":
						r.push(`suede ankle strap pumps.`);
						break;
					case "extreme heels":
						r.push(`suede ankle strap heels so tall, ${he} has to walk with ${his} ass sticking out.`);
						break;
					case "platform shoes":
						r.push(`suede platform shoes.`);
						break;
					case "platform heels":
						r.push(`suede ankle strap platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`suede ankle strap platform heels so tall, ${he} has to walk with ${his} ass sticking out.`);
						break;
					default:
						r.push(`bare feet.`);
				}
				break;
			case "a comfortable bodysuit":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of comfortable shoes.`);
						break;
					case "boots":
						r.push(`a pair of heeled boots.`);
						break;
					case "heels":
						r.push(`a pair of heels.`);
						break;
					case "pumps":
						r.push(`a pair of pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of heels so extreme ${he}'s practically on tiptoe.`);
						break;
					case "platform shoes":
						r.push(`a pair of platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of platform heels so extreme ${he}'s practically on tiptoe.`);
						break;
					default:
						r.push(`nothing on ${his} feet, each individual toe of which is perfectly wrapped by the bodysuit.`);
				}
				break;
			case "a tube top and thong":
			case "a bra":
			case "a thong":
			case "a tube top":
			case "a striped bra":
			case "striped underwear":
			case "boyshorts":
			case "cutoffs":
			case "panties":
			case "panties and pasties":
			case "pasties":
			case "jeans":
			case "a button-up shirt and panties":
			case "a button-up shirt":
			case "a t-shirt and jeans":
			case "an oversized t-shirt and boyshorts":
			case "an oversized t-shirt":
			case "a t-shirt and panties":
			case "a t-shirt":
			case "a sweater and cutoffs":
			case "a sweater":
			case "a tank-top":
			case "a sweater and panties":
			case "a tank-top and panties":
			case "a t-shirt and thong":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of comfortable shoes.`);
						break;
					case "boots":
						r.push(`a pair of heeled boots.`);
						break;
					case "heels":
						r.push(`a pair of heels.`);
						break;
					case "pumps":
						r.push(`a pair of pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of heels so extreme ${he}'s practically on tiptoe.`);
						break;
					case "platform shoes":
						r.push(`a pair of platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of platform heels so extreme ${he}'s practically on tiptoe.`);
						break;
					default:
						r.push(`nothing on ${his} feet.`);
				}
				break;
			case "a sports bra":
			case "sport shorts and a t-shirt":
			case "sport shorts":
			case "sport shorts and a sports bra":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of athletic shoes.`);
						break;
					case "boots":
						r.push(`a pair of athletic heeled boots.`);
						break;
					case "heels":
						r.push(`a pair of athletic heels.`);
						break;
					case "pumps":
						r.push(`a pair of athletic pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of athletic heels so extreme ${he}'s practically on tiptoe.`);
						break;
					case "platform shoes":
						r.push(`a pair of athletic platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of ankle-supporting platform heels to protect ${him} from sprains.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of extremely tall, but ankle-supporting, platform heels to protect ${him} from sprains.`);
						break;
					default:
						r.push(`nothing on ${his} feet.`);
				}
				break;
			case "a nice pony outfit":
			case "a slutty pony outfit":
			case "leather pants and pasties":
			case "leather pants":
			case "leather pants and a tube top":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of slutty shoes.`);
						break;
					case "boots":
						r.push(`a pair of slutty heeled boots.`);
						break;
					case "heels":
						r.push(`a pair of slutty heels.`);
						break;
					case "pumps":
						r.push(`a pair of slutty pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of slutty heels so extreme ${he}'s practically on tiptoe.`);
						break;
					case "platform shoes":
						r.push(`a pair of slutty platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of slutty platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of slutty platform heels so extreme ${he}'s practically on tiptoe.`);
						break;
					default:
						r.push(`nothing on ${his} feet.`);
				}
				break;
			case "a leotard":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of athletic shoes.`);
						break;
					case "boots":
						r.push(`a pair of high-topped athletic boots.`);
						break;
					case "heels":
						r.push(`a pair of high-heeled athletic shoes.`);
						break;
					case "pumps":
						r.push(`a pair of pump athletic shoes.`);
						break;
					case "extreme heels":
						r.push(`ballet shoes made to force ${him} to walk en pointe.`);
						break;
					case "platform shoes":
						r.push(`a pair of athletic platform shoes.`);
						break;
					case "platform heels":
						r.push(`a pair of platform heels that make ${him} look like ${he} is walking en pointe.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of platform heels so unwieldy that every step must be made with the grace of a dancer.`);
						break;
					default:
						r.push(`nothing on ${his} feet, which are covered by the leotard.`);
				}
				break;
			case "a burkini":
			case "a one-piece swimsuit":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of open-toed sandals.`);
						break;
					case "boots":
						r.push(`a pair of colorful rubber boots.`);
						break;
					case "heels":
						r.push(`a pair of waterproof heels.`);
						break;
					case "pumps":
						r.push(`a pair of colorful rubber pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of extreme yet swim-ready heels.`);
						break;
					case "platform shoes":
						r.push(`a pair of platform sandals.`);
						break;
					case "platform heels":
						r.push(`a pair of waterproof platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of extreme yet swim-ready platform heels.`);
						break;
					default:
						r.push(`leaves ${his} feet bare.`);
				}
				break;
			case "a monokini":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of open-toed sandals.`);
						break;
					case "boots":
						r.push(`a pair of go-go boots.`);
						break;
					case "heels":
						r.push(`a pair of sand-ready heels.`);
						break;
					case "pumps":
						r.push(`a pair of colorful pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of dangerously tall heels still stable enough to walk through sand.`);
						break;
					case "platform shoes":
						r.push(`a pair of platform sandals.`);
						break;
					case "platform heels":
						r.push(`a pair of platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of dangerously tall platform heels.`);
						break;
					default:
						r.push(`leaves ${his} feet bare.`);
				}
				break;
			case "an apron":
				switch (slave.shoes) {
					case "flats":
						r.push(`aside from a pair of suede flats.`);
						break;
					case "boots":
						r.push(`aside from a pair of suede thigh-high boots.`);
						break;
					case "heels":
						r.push(`aside from a pair of suede ankle strap heels.`);
						break;
					case "pumps":
						r.push(`aside from a pair of suede ankle strap pumps.`);
						break;
					case "extreme heels":
						r.push(`aside from a pair of suede ankle strap heels so tall, ${he} has to walk with ${his} ass sticking out.`);
						break;
					case "platform shoes":
						r.push(`aside from a pair of suede platform shoes.`);
						break;
					case "platform heels":
						r.push(`aside from a pair of suede ankle strap platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`aside from a pair of suede ankle strap platform heels so tall, ${he} has to walk with ${his} ass sticking out and ${his} chest thrust forward.`);
						break;
					default:
						r.push(`all the way down to ${his} feet.`);
				}
				break;
			case "a Santa dress":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of black slippers.`);
						break;
					case "boots":
						r.push(`a pair of long black boots.`);
						break;
					case "heels":
						r.push(`a pair of black high heels.`);
						break;
					case "pumps":
						r.push(`a pair of black pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of dangerously tall black high heels.`);
						break;
					case "platform shoes":
						r.push(`a pair of black platform shoes with built-in jingle bells.`);
						break;
					case "platform heels":
						r.push(`a pair of black platform heels with built-in jingle bells.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of dangerously tall black platform heels with built-in jingle bells.`);
						break;
					default:
						r.push(`nothing on ${his} feet.`);
				}
				break;
			case "a cybersuit":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of short rubberized combat boots.`);
						break;
					case "boots":
						r.push(`a pair of rubberized combat boots.`);
						break;
					case "heels":
						r.push(`a pair of rubberized heels, accentuating ${his} ass.`);
						break;
					case "pumps":
						r.push(`a pair of rubberized pumps, accentuating ${his} ass.`);
						break;
					case "extreme heels":
						r.push(`a pair dangerously tall rubberized heels.`);
						break;
					case "platform shoes":
						r.push(`a pair of rubberized platform boots.`);
						break;
					case "platform heels":
						r.push(`a pair of rubberized platform heels, accentuating ${his} ass.`);
						break;
					case "extreme platform heels":
						r.push(`a pair dangerously tall rubberized heels, forcing ${him} to stick out ${his} ass.`);
						break;
					default:
						r.push(`leaves ${his} feet bare.`);
				}
				break;
			case "a tight Imperial bodysuit":
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of short rubberized combat boots.`);
						break;
					case "boots":
						r.push(`a pair of rubberized combat boots.`);
						break;
					case "heels":
						r.push(`a pair of rubberized heels, accentuating ${his} bodysuited ass.`);
						break;
					case "pumps":
						r.push(`a pair of rubberized pumps, accentuating ${his} bodysuited ass.`);
						break;
					case "extreme heels":
						r.push(`a pair dangerously tall rubberized heels.`);
						break;
					case "platform shoes":
						r.push(`a pair of rubberized platform boots.`);
						break;
					case "platform heels":
						r.push(`a pair of rubberized platform heels, accentuating ${his} bodysuited ass.`);
						break;
					case "extreme platform heels":
						r.push(`a pair dangerously tall rubberized heels, forcing ${him} to stick out ${his} bodysuited ass.`);
						break;
					default:
						r.push(`leaves ${his} feet bare.`);
				}
				break;
			case "a bunny outfit":
				switch (slave.shoes) {
					case "flats":
						r.push(`kitten-heeled strap sandals.`);
						break;
					case "boots":
						r.push(`high-heeled boots that match ${his} teddy.`);
						break;
					case "heels":
						r.push(`high heels that match ${his} teddy.`);
						break;
					case "pumps":
						r.push(`high pumps that match ${his} teddy.`);
						break;
					case "extreme heels":
						r.push(`painfully high heels that match ${his} teddy.`);
						break;
					case "platform shoes":
						r.push(`platform shoes that match ${his} teddy.`);
						break;
					case "platform heels":
						r.push(`platform heels that match ${his} teddy.`);
						break;
					case "extreme platform heels":
						r.push(`painfully tall platform heels that match ${his} teddy.`);
						break;
					default:
						r.push(`${his} bare feet.`);
				}
				break;
			case "a slutty maid outfit":
				switch (slave.shoes) {
					case "flats":
						r.push(`little black shoes.`);
						break;
					case "boots":
						r.push(`rubber work boots for mopping the floor.`);
						break;
					case "heels":
						r.push(`little sleek heels.`);
						break;
					case "pumps":
						r.push(`little sleek pumps.`);
						break;
					case "extreme heels":
						r.push(`black pump heels that raise ${his} practically bare butt to dick height.`);
						break;
					case "platform shoes":
						r.push(`rubber platform shoes to keep ${his} feet off the floors.`);
						break;
					case "platform heels":
						r.push(`sleek platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`black platform heels that raise ${his} practically bare butt to dick height.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a nice maid outfit":
				switch (slave.shoes) {
					case "flats":
						r.push(`little black shoes.`);
						break;
					case "boots":
						r.push(`rubber work boots for mopping the floor.`);
						break;
					case "heels":
						r.push(`little sleek heels.`);
						break;
					case "pumps":
						r.push(`little sleek pumps.`);
						break;
					case "extreme heels":
						r.push(`black pump heels of inconvenient height.`);
						break;
					case "platform shoes":
						r.push(`rubber platform shoes to keep ${his} feet off the floors.`);
						break;
					case "platform heels":
						r.push(`sleek platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`black platform heels that render even the highest shelf quite dustable.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a slutty nurse outfit":
				switch (slave.shoes) {
					case "flats":
						r.push(`white flat shoes.`);
						break;
					case "boots":
						r.push(`white leather boots that come up ${his} thighs to`);
						if (V.showInches === 2) {
							r.push(`an inch`);
						} else {
							r.push(`three centimeters`);
						}
						r.push(`below the hem of ${his} skirt.`);
						break;
					case "heels":
						r.push(`white fuck-me heels.`);
						break;
					case "pumps":
						r.push(`white low heeled pumps.`);
						break;
					case "extreme heels":
						r.push(`white pump heels so tall ${he} can barely totter along.`);
						break;
					case "platform shoes":
						r.push(`white platform shoes emblazoned with crosses.`);
						break;
					case "platform heels":
						r.push(`white platform heels emblazoned with crosses.`);
						break;
					case "extreme platform heels":
						r.push(`white platform heels so tall ${he} can barely totter along.`);
						break;
					default:
						r.push(`bare feet.`);
				}
				break;
			case "a nice nurse outfit":
				switch (slave.shoes) {
					case "flats":
						r.push(`practical white nursing clogs.`);
						break;
					case "boots":
						r.push(`white leather boots underneath ${his} pant legs.`);
						break;
					case "heels":
						r.push(`modest white heels.`);
						break;
					case "pumps":
						r.push(`modest white pumps.`);
						break;
					case "extreme heels":
						r.push(`impractically high heeled white pumps.`);
						break;
					case "platform shoes":
						r.push(`modest white platform shoes.`);
						break;
					case "platform heels":
						r.push(`modest white platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`impractically high white platform heels.`);
						break;
					default:
						r.push(`disposable foot covers over socks.`);
				}
				break;
			case "a schoolgirl outfit":
				switch (slave.shoes) {
					case "flats":
						r.push(`girly tennis shoes with bright white laces.`);
						break;
					case "boots":
						r.push(`brown leather riding boots with buckled tops.`);
						break;
					case "heels":
						r.push(`black heels with little plaid bows.`);
						break;
					case "pumps":
						r.push(`black pumps with little plaid bows.`);
						break;
					case "extreme heels":
						r.push(`tall black pump heels with little plaid bows.`);
						break;
					case "platform shoes":
						r.push(`girly platform shoes with bright white laces.`);
						break;
					case "platform heels":
						r.push(`black platform heels with little plaid bows.`);
						break;
					case "extreme platform heels":
						r.push(`tall black platform heels that force ${him} to walk with ${his} ass sticking out.`);
						break;
					default:
						r.push(`bare feet.`);
				}
				break;
			case "a kimono":
				switch (slave.shoes) {
					case "flats":
						r.push(`getae over tabi socks.`);
						break;
					case "boots":
						r.push(`black jika-tabi boots.`);
						break;
					case "heels":
						r.push(`tall getae over tabi socks.`);
						break;
					case "pumps":
						r.push(`tall getae over tabi socks.`);
						break;
					case "extreme heels":
						r.push(`towering getae over tabi socks.`);
						break;
					case "platform shoes":
						r.push(`hardwood platforms over tabi socks.`);
						break;
					case "platform heels":
						r.push(`platform heels carved from hardwood.`);
						break;
					case "extreme platform heels":
						r.push(`extremely tall platform heels carved from hardwood.`);
						break;
					default:
						r.push(`bare feet.`);
				}
				break;
			case "a burqa":
			case "a hijab and abaya":
			case "a niqab and abaya":
				switch (slave.shoes) {
					case "flats":
						r.push(`sport a pair of simple black slippers.`);
						break;
					case "boots":
						r.push(`sport a pair of black leather boots.`);
						break;
					case "heels":
						r.push(`sport a pair of modest black heels.`);
						break;
					case "pumps":
						r.push(`sport a pair of modest black pumps.`);
						break;
					case "extreme heels":
						r.push(`sport a pair of immodestly tall black heels.`);
						break;
					case "platform shoes":
						r.push(`sport a pair of simple black platform shoes.`);
						break;
					case "platform heels":
						r.push(`sport a pair of modest black platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`sport a pair of immodestly tall black platform heels.`);
						break;
					default:
						r.push(`are totally bare.`);
				}
				break;
			case "a klan robe":
			case "a slutty klan robe":
				switch (slave.shoes) {
					case "flats":
						r.push(`sport a pair of simple slippers.`);
						break;
					case "boots":
						r.push(`sport a pair of leather boots.`);
						break;
					case "heels":
						r.push(`sport a pair of modest heels.`);
						break;
					case "pumps":
						r.push(`sport a pair of modest pumps.`);
						break;
					case "extreme heels":
						r.push(`sport a pair of immodestly tall heels.`);
						break;
					case "platform shoes":
						r.push(`sport a pair of simple platform shoes.`);
						break;
					case "platform heels":
						r.push(`sport a pair of modest platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`sport a pair of immodestly tall platform heels.`);
						break;
					default:
						r.push(`are totally bare.`);
				}
				break;
			case "a military uniform":
			case "a police uniform":
			case "a schutzstaffel uniform":
			case "a slutty schutzstaffel uniform":
			case "a red army uniform":
			case "a mounty outfit":
				switch (slave.shoes) {
					case "flats":
						r.push(`polished Oxford shoes.`);
						break;
					case "boots":
						r.push(`tall black leather boots.`);
						break;
					case "heels":
						r.push(`modest black service heels.`);
						break;
					case "pumps":
						r.push(`modest black service pumps.`);
						break;
					case "extreme heels":
						r.push(`extremely high heeled ceremonial dress boots that force ${him} to constantly stand at attention.`);
						break;
					case "platform shoes":
						r.push(`leather service boots with a built-in platform.`);
						break;
					case "platform heels":
						r.push(`modest black service platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`extremely high heeled ceremonial platform dress boots that force ${him} to constantly stand at attention.`);
						break;
					default:
						r.push(`a complete lack of regulation footwear.`);
				}
				break;
			case "battlearmor":
				switch (slave.shoes) {
					case "flats":
						r.push(`polished service shoes.`);
						break;
					case "boots":
						r.push(`tall combat boots.`);
						break;
					case "heels":
						r.push(`modest service heels.`);
						break;
					case "pumps":
						r.push(`modest service pumps.`);
						break;
					case "extreme heels":
						r.push(`extremely high heeled ceremonial dress boots that force ${him} to constantly stand at attention.`);
						break;
					case "platform shoes":
						r.push(`leather combat boots with a built-in platform.`);
						break;
					case "platform heels":
						r.push(`modest service platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`extremely high heeled ceremonial platform dress boots that force ${him} to constantly stand at attention.`);
						break;
					default:
						r.push(`a complete lack of regulation footwear.`);
				}
				break;
			case "Imperial Plate":
				switch (slave.shoes) {
					case "flats":
						r.push(`flatly armored shoes.`);
						break;
					case "boots":
						r.push(`intimidatingly plated boots.`);
						break;
					case "heels":
						r.push(`plate-armor heels.`);
						break;
					case "pumps":
						r.push(`plate-armor pumps.`);
						break;
					case "extreme heels":
						r.push(`comically high plate-armor heels that somehow render ${his} entire ultra-heavy armor far less intimidating.`);
						break;
					case "platform shoes":
						r.push(`platformed, plate-armor boots.`);
						break;
					case "platform heels":
						r.push(`platformed, plate-armor heels.`);
						break;
					case "extreme platform heels":
						r.push(`absurdly high platform heels that flash with integrated cybernetics.`);
						break;
					default:
						r.push(`bare feet that awkwardly stand as the only piece of exposed flesh on ${his} entire heavily-armored body.`);
				}
				break;
			case "a long qipao":
				switch (slave.shoes) {
					case "flats":
						r.push(`polished oriental flats.`);
						break;
					case "boots":
						r.push(`tall oriental boots.`);
						break;
					case "heels":
						r.push(`modest oriental heels.`);
						break;
					case "pumps":
						r.push(`modest oriental pumps.`);
						break;
					case "extreme heels":
						r.push(`extremely high heeled oriental boots.`);
						break;
					case "platform shoes":
						r.push(`polished platform shoes with an oriental design.`);
						break;
					case "platform heels":
						r.push(`modest oriental platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`extreme platform heels with intricate oriental designs.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a gothic lolita dress":
				switch (slave.shoes) {
					case "flats":
						r.push(`polished Victorian flats.`);
						break;
					case "boots":
						r.push(`tall Victorian boots.`);
						break;
					case "heels":
						r.push(`modest Victorian heels.`);
						break;
					case "pumps":
						r.push(`modest Victorian pumps.`);
						break;
					case "extreme heels":
						r.push(`extremely high heeled Victorian boots.`);
						break;
					case "platform shoes":
						r.push(`platform shoes with a Victorian flair.`);
						break;
					case "platform heels":
						r.push(`platform heels with a Victorian flair.`);
						break;
					case "extreme platform heels":
						r.push(`tall platform heels with a Victorian flair.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a dirndl":
				switch (slave.shoes) {
					case "flats":
						r.push(`polished traditional laced shoes.`);
						break;
					case "boots":
						r.push(`tall traditional laced boots.`);
						break;
					case "heels":
						r.push(`modest traditional laced heels.`);
						break;
					case "pumps":
						r.push(`modest traditional laced pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of daringly high traditional laced heels.`);
						break;
					case "platform shoes":
						r.push(`polished traditional laced platform shoes.`);
						break;
					case "platform heels":
						r.push(`modest traditional laced platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of daringly high traditional laced platform heels.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "lederhosen":
				switch (slave.shoes) {
					case "flats":
						r.push(`polished traditional shoes.`);
						break;
					case "boots":
						r.push(`tall traditional boots.`);
						break;
					case "heels":
						r.push(`modest traditional heels.`);
						break;
					case "pumps":
						r.push(`modest traditional pumps.`);
						break;
					case "extreme heels":
						r.push(`a pair of daringly high traditional heels.`);
						break;
					case "platform shoes":
						r.push(`polished traditional laced platform shoes.`);
						break;
					case "platform heels":
						r.push(`modest traditional platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of daringly high traditional platform heels.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "a biyelgee costume":
			case "a hanbok":
				switch (slave.shoes) {
					case "flats":
						r.push(`ornamental dancing shoes.`);
						break;
					case "boots":
						r.push(`bright sturdy boots.`);
						break;
					case "heels":
						r.push(`bright ornamental heels.`);
						break;
					case "pumps":
						r.push(`bright ornamental pumps.`);
						break;
					case "extreme heels":
						r.push(`extremely high heeled ornamental dress boots that force ${him} to constantly rock ${his} hips to shift ${his} weight.`);
						break;
					case "platform shoes":
						r.push(`bright ornamental platform shoes.`);
						break;
					case "platform heels":
						r.push(`bright ornamental platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`extremely tall ornamental platform heels that force ${him} to constantly rock ${his} hips to shift ${his} weight.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "battledress":
				switch (slave.shoes) {
					case "flats":
						r.push(`low topped patrol shoes.`);
						break;
					case "boots":
						r.push(`practical combat boots.`);
						break;
					case "heels":
						r.push(`high-heeled combat boots.`);
						break;
					case "pumps":
						r.push(`pump-like combat boots.`);
						break;
					case "extreme heels":
						r.push(`combat boots with heels so tall as to almost immobilize ${him}.`);
						break;
					case "platform shoes":
						r.push(`sturdy platform combat boots.`);
						break;
					case "platform heels":
						r.push(`impractical platform heeled combat boots.`);
						break;
					case "extreme platform heels":
						r.push(`combat boots with a heeled platform so tall that they are practically immobilizing.`);
						break;
					default:
						r.push(`bare feet, VC style.`);
				}
				break;
			case "harem gauze":
				switch (slave.shoes) {
					case "flats":
						r.push(`jeweled thong sandals.`);
						break;
					case "boots":
						r.push(`long leather boots worked with beautiful golden filigree.`);
						break;
					case "heels":
						r.push(`high heels decorated with golden filigree.`);
						break;
					case "pumps":
						r.push(`high pumps decorated with golden filigree.`);
						break;
					case "extreme heels":
						r.push(`extremely high heels decorated with golden filigree.`);
						break;
					case "platform shoes":
						r.push(`platform shoes with beautiful eastern patterns worked into the sides in lapis lazuli.`);
						break;
					case "platform heels":
						r.push(`platform heels with beautiful eastern patterns worked into the sides in lapis lazuli.`);
						break;
					case "extreme platform heels":
						r.push(`tall platform heels with beautiful eastern patterns worked into the sides in lapis lazuli.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet.`);
				}
				break;
			case "slutty jewelry":
				r.push(`bangles which`);
				switch (slave.shoes) {
					case "flats":
						r.push(`connect to the thin straps of a pair of sandals of the same golden chain.`);
						break;
					case "boots":
						r.push(`crisscross ${his} thighs and calves down to a pair of soles to form boots of golden chains.`);
						break;
					case "heels":
						r.push(`crisscross ${his} thighs and calves down to a pair of golden heels.`);
						break;
					case "pumps":
						r.push(`crisscross ${his} thighs and calves down to a pair of golden pumps.`);
						break;
					case "extreme heels":
						r.push(`crisscross ${his} thighs and calves down to a pair of excruciatingly high golden heels.`);
						break;
					case "platform shoes":
						r.push(`crisscross ${his} thighs and calves down to a pair of golden platforms.`);
						break;
					case "platform heels":
						r.push(`crisscross ${his} thighs and calves down to a pair of golden platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`crisscross ${his} thighs and calves down to a pair of excruciatingly high golden platform heels.`);
						break;
					default:
						r.push(`end at mid-calf, leaving ${his} feet bare except for a set of jeweled toe-rings.`);
				}

				r.push(App.Desc.piercing(slave, "chastity"));
				break;
			case "a courtesan dress":
				switch (slave.shoes) {
					case "flats":
						r.push(`an elegant pair of dancing slippers.`);
						break;
					case "boots":
						r.push(`an elegant pair of heeled booties.`);
						break;
					case "heels":
						r.push(`an elegant pair of heels.`);
						break;
					case "pumps":
						r.push(`an elegant pair of pumps.`);
						break;
					case "extreme heels":
						r.push(`an elegant pair of excruciatingly high heels that test ${his} grace.`);
						break;
					case "platform shoes":
						r.push(`a fragile pair of platform shoes.`);
						break;
					case "platform heels":
						r.push(`a fragile pair of platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`a fragile pair of excruciatingly high platform heels that test ${his} focus with each step.`);
						break;
					default:
						r.push(`elegantly bare feet.`);
				}
				break;
			case "a bimbo outfit":
				switch (slave.shoes) {
					case "flats":
						r.push(`pink flat shoes.`);
						break;
					case "boots":
						r.push(`leather boots that come up ${his} knees.`);
						break;
					case "heels":
						r.push(`pink fuck-me heels.`);
						break;
					case "pumps":
						r.push(`pink low heeled pumps.`);
						break;
					case "extreme heels":
						r.push(`pink heels so tall ${he} has to push ${his} ass out and ${his} chest forward just to keep balance.`);
						break;
					case "platform shoes":
						r.push(`pink platform shoes.`);
						break;
					case "platform heels":
						r.push(`pink platform heels.`);
						break;
					case "extreme platform heels":
						r.push(`pink platform heels so tall ${he} has to push ${his} ass out and ${his} chest forward just to keep balance.`);
						break;
					default:
						r.push(`bare feet.`);
				}
				break;
			default:
				switch (slave.shoes) {
					case "flats":
						r.push(`a pair of simple sandals which just call attention to ${his} otherwise nude state.`);
						break;
					case "boots":
						r.push(`a pair of sexy leather boots which just call attention to ${his} otherwise nude state.`);
						break;
					case "heels":
						r.push(`a pair of sexy heels which just call attention to ${his} otherwise nude state.`);
						break;
					case "pumps":
						r.push(`a pair of sexy pumps which just call attention to ${his} otherwise nude state.`);
						break;
					case "extreme heels":
						r.push(`a pair of daringly high heels which just call attention to ${his} otherwise nude state.`);
						break;
					case "platform shoes":
						r.push(`a pair of simple platform shoes which just call attention to ${his} otherwise nude state.`);
						break;
					case "platform heels":
						r.push(`a pair of sexy platform heels which just call attention to ${his} otherwise nude state.`);
						break;
					case "extreme platform heels":
						r.push(`a pair of daringly high platform heels which just call attention to ${his} otherwise nude state.`);
						break;
					default:
						r.push(`nothing on ${his} bare feet either, naturally.`);
				}
		}

		switch (slave.legAccessory) {
			// split stocking descriptions from above into here
			// I think these need to be integrated into the above switch statement and placed prior to the shoe descs
			case "short stockings":
				switch (slave.clothes) {
					case "no clothing":
					case "an apron":
					case "a thong":
					case "a skimpy loincloth":
					case "body oil":
					case "boyshorts":
					case "panties":
					case "panties and pasties":
						if (hasBothLegs(slave)) {
							r.push(`${He} is wearing a pair of short${slave.collar === "leather with cowbell" ? " cow print" : ""} stockings that end just below ${his} knees.`);
						} else {
							r.push(`${He} is wearing a short${slave.collar === "leather with cowbell" ? " cow print" : ""} stocking that ends just below ${his} knee.`);
						}
						break;
					default:
						if (hasBothLegs(slave)) {
							r.push(`${He} is wearing a pair of short stockings that end just below ${his} knees.`);
						} else {
							r.push(`${He} is wearing a short stocking that ends just below ${his} knee.`);
						}
				}
				break;
			case "long stockings":
				switch (slave.clothes) {
					case "no clothing":
					case "an apron":
					case "a thong":
					case "a skimpy loincloth":
					case "boyshorts":
					case "body oil":
					case "panties":
					case "panties and pasties":
						if (hasBothLegs(slave)) {
							r.push(`${He} is wearing a pair of long${slave.collar === "leather with cowbell" ? " cow print" : ""} stockings that come up to the middle of ${his} thighs.`);
						} else {
							r.push(`${He} is wearing a long${slave.collar === "leather with cowbell" ? " cow print" : ""} stocking that come up to the middle of ${his} thigh.`);
						}
						break;
					default:
						if (hasBothLegs(slave)) {
							r.push(`${He} is wearing a pair of long stockings that come up to the middle of ${his} thighs.`);
						} else {
							r.push(`${He} is wearing a long stocking that come up to the middle of ${his} thigh.`);
						}
				}
				break;
		}
	}
	// end amp check

	return r.join(" ");
};
