/**
 * @param {App.Entity.SlaveState} slave
 * @param {object} params
 * @param {number} [params.market]
 * @param {number} [params.eventDescription]
 * @returns {string}
 */
App.Desc.superfetation = function(slave, {market, eventDescription} = {}) {
	const r = [];
	const {
		his, His
	} = getPronouns(slave);
	let lsd;
	let daddy;
	const slaveWD = WombGetLittersData(slave);
	if (slave.geneticQuirks.superfetation === 2 && slaveWD.litters.length > 1 && V.pregnancyMonitoringUpgrade === 1 && !market) {
		r.push(`${His} womb contains ${num(slaveWD.litters.length)} separate pregnancies`);
		for (let litCount = 0; litCount < slaveWD.litters.length; litCount++) {
			const countLitter = slaveWD.countLitter[litCount];
			const is = countLitter > 1 ? "are" : "is";
			const was = countLitter > 1 ? "were" : "was";
			if (litCount === 0) {
				r.push(`the eldest`);
				if (countLitter > 1) {
					r.push(`set of ${num(countLitter)},`);
				} else {
					r.push(`one,`);
				}
				r.push(`at ${slaveWD.litters[litCount]}`);
				if (slaveWD.litters[litCount] > 1) {
					r.push(`weeks`);
				} else {
					r.push(`week`);
				}
				r.push(`of development,`);
				if (slaveWD.litterData[litCount][0].fatherID === -7) {
					r.push(`${is} from the gene lab,`);
				} else if (slaveWD.litterData[litCount][0].age > slave.pregData.normalBirth / 8) {
					if (slaveWD.litterData[litCount][0].fatherID === -1) {
						r.push(`${was} fathered by your seed,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -2) {
						r.push(`${was} fathered by one of your citizens,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -3) {
						r.push(`${was} fathered by your former Master,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -4) {
						r.push(`${was} fathered by another arcology owner,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -5) {
						r.push(`${was} fathered by one of your clients,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -6) {
						r.push(`${was} fathered by a member of the Societal Elite,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -9) {
						r.push(`${was} fathered by the Futanari Sisters,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === 0) {
						r.push(`${is} from an unidentifiable source,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === slave.ID) {
						r.push(`${is} from ${his} own handiwork,`);
					} else {
						if (slaveWD.litterData[litCount][0].fatherID > 0) {
							lsd = findFather(slaveWD.litterData[litCount][0].fatherID);
							if (lsd) {
								daddy = SlaveFullName(lsd);
							} else {
								daddy = "another slave";
							}
						} else if (slaveWD.litterData[litCount][0].fatherID in V.missingTable && V.showMissingSlaves) {
							daddy = V.missingTable[slave.pregSource].fullName;
						}
						r.push(`${was} fathered by ${daddy}'s seed,`);
					}
				} else {
					r.push(`${is} too young to tell the father of,`);
				}
			} else if (litCount === slaveWD.litters.length - 1) {
				r.push(`and the youngest`);
				if (countLitter > 1) {
					r.push(`set of ${num(countLitter)},`);
				} else {
					r.push(`one,`);
				}
				r.push(`at ${slaveWD.litters[litCount]}`);
				if (slaveWD.litters[litCount] > 1) {
					r.push(`weeks`);
				} else {
					r.push(`week`);
				}
				r.push(`of development,`);
				if (slaveWD.litterData[litCount][0].fatherID === -7) {
					r.push(`${is} from the gene lab.`);
				} else if (slaveWD.litterData[litCount][0].age > slave.pregData.normalBirth / 8) {
					if (slaveWD.litterData[litCount][0].fatherID === -1) {
						r.push(`${was} fathered by your seed.`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -2) {
						r.push(`${was} fathered by one of your citizens.`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -3) {
						r.push(`${was} fathered by your former Master. He was quite the busy man.`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -4) {
						r.push(`${was} fathered by another arcology owner.`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -5) {
						r.push(`${was} fathered by one of your clients.`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -6) {
						r.push(`${was} fathered by a member of the Societal Elite.`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -9) {
						r.push(`${was} fathered by the Futanari Sisters.`);
					} else if (slaveWD.litterData[litCount][0].fatherID === 0) {
						r.push(`${is} from an unidentifiable source.`);
					} else if (slaveWD.litterData[litCount][0].fatherID === slave.ID) {
						r.push(`${is} from ${his} own seed.`);
					} else {
						if (slaveWD.litterData[litCount][0].fatherID > 0) {
							lsd = findFather(slaveWD.litterData[litCount][0].fatherID);
							if (lsd) {
								daddy = SlaveFullName(lsd);
							} else {
								daddy = "another slave";
							}
						} else if (slaveWD.litterData[litCount][0].fatherID in V.missingTable && V.showMissingSlaves) {
							daddy = V.missingTable[slave.pregSource].fullName;
						}
						r.push(`${was} fathered by ${daddy}'s seed.`);
					}
				} else {
					r.push(`${is} too young to tell the father of.`);
				}
			} else {
				r.push(`the next set of ${num(countLitter)} at ${slaveWD.litters[litCount]}`);
				if (slaveWD.litters[litCount] > 1) {
					r.push(`weeks`);
				} else {
					r.push(`week`);
				}
				r.push(`of development`);
				if (slaveWD.litterData[litCount][0].fatherID === -7) {
					r.push(`${is} from the gene lab,`);
				} else if (slaveWD.litterData[litCount][0].age > slave.pregData.normalBirth / 8) {
					if (slaveWD.litterData[litCount][0].fatherID === -1) {
						r.push(`${was} fathered by your seed,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -2) {
						r.push(`${was} fathered by one of your citizens,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -3) {
						r.push(`${was} fathered by your former Master,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -4) {
						r.push(`${was} fathered by another arcology owner,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -5) {
						r.push(`${was} fathered by one of your clients,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -6) {
						r.push(`${was} fathered by a member of the Societal Elite,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === -9) {
						r.push(`${was} fathered by the Futanari Sisters,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === 0) {
						r.push(`${is} from an unidentifiable source,`);
					} else if (slaveWD.litterData[litCount][0].fatherID === slave.ID) {
						r.push(`${is} from ${his} own handiwork,`);
					} else {
						if (slaveWD.litterData[litCount][0].fatherID > 0) {
							lsd = findFather(slaveWD.litterData[litCount][0].fatherID);
							if (lsd) {
								daddy = SlaveFullName(lsd);
							} else {
								daddy = "another slave";
							}
						} else if (slaveWD.litterData[litCount][0].fatherID in V.missingTable && V.showMissingSlaves) {
							daddy = V.missingTable[slave.pregSource].fullName;
						}
						r.push(`${was} fathered by ${daddy}'s seed,`);
					}
				} else {
					r.push(`${is} too young to tell the father of,`);
				}
			}
		}
	}
	return r.join(" ");
};
