App.Medicine.Modification.Select.brand = function(slave, cheat = false) {
	const el = new DocumentFragment();
	let p = document.createElement('p');
	let div = document.createElement('div');
	const {his, His, him, He} = getPronouns(slave);

	p.classList.add("indent");
	for (const brandPlace in slave.brand) {
		div = document.createElement('div');
		div.append(`${His} ${brandPlace} is marked with ${slave.brand[brandPlace]}`);
		if (slave.brand[brandPlace] === V.brandDesign.official) {
			div.append(`, your `);
			div.append(App.UI.DOM.passageLink("official brand", "Universal Rules"));
		}
		div.append(": ");
		if (!cheat) {
			div.append(
				App.UI.DOM.link(
					"Remove Brand",
					() => {
						V.brandApplied = 0;
						delete slave.brand[brandPlace];
						cashX(forceNeg(V.surgeryCost), "slaveSurgery", slave);
						V.degradation -= 10;
					},
					[],
					"Body Modification"
				)
			);
		} else {
			div.append(
				App.UI.DOM.link(
					"Remove Brand",
					() => {
						delete slave.brand[brandPlace];
						App.Medicine.Modification.Select.brand(slave, cheat); // Refresh display
					},
				)
			);
		}
		p.append(div);
	}

	if (jQuery.isEmptyObject(slave.brand)) {
		App.UI.DOM.appendNewElement("div", p, `${His} skin is unmarked.`);
	}

	if (!(Object.values(slave.brand).includes(V.brandDesign.official))) {
		div = document.createElement('div');
		div.append(`${He} lacks your `);
		div.append(App.UI.DOM.passageLink("official brand", "Universal Rules"));
		div.append(`, "${V.brandDesign.official}."`);
		p.append(div);
	}

	el.append(p);
	p = document.createElement('p');
	p.classList.add("indent");


	div = document.createElement('div');
	div.append(`Use ''${V.brandDesign.local}'' or choose another brand: `);
	div.append(symbolOptions("personal"));
	p.append(div);

	p.append(symbolBlock("dirtyWord"));
	p.append(symbolBlock("genitalSymbol"));
	p.append(symbolBlock("silhouettes"));
	p.append(symbolBlock("FS"));

	div = document.createElement('div');
	div.classList.add("indent");
	div.append(`Or design your own: `);
	div.append(
		App.UI.DOM.makeTextBox(
			V.brandDesign.local,
			v => {
				V.brandDesign.local = v;
				App.Medicine.Modification.Select.brand(slave, cheat); // Refresh display
			},
		)
	);
	p.append(div);
	el.append(p);

	p = document.createElement('p');
	p.classList.add("indent");
	App.UI.DOM.appendNewElement("div", p, "Choose a site for branding: ");
	const body = slaveBody();
	p.append(partLinks(body.head));
	p.append(partLinks(body.torso));
	p.append(partLinks(body.arms));
	p.append(partLinks(body.legs));

	div = document.createElement('div');
	div.classList.add("indent");
	div.append(`Or a custom site:  `);
	div.append(
		App.UI.DOM.makeTextBox(
			V.brandTarget.local,
			v => {
				V.brandTarget.local = v;
				App.Medicine.Modification.Select.brand(slave, cheat); // Refresh display
			},
		)
	);
	p.append(div);
	el.append(p);

	p = document.createElement('p');
	p.classList.add("indent");

	if (["ankle", "breast", "buttock", "calf", "cheek", "ear", "foot", "hand", "lower arm", "shoulder", "testicle", "thigh", "upper arm", "wrist"].includes(V.brandTarget.local)) {
		const leftTarget = ("left " + V.brandTarget.local);
		const rightTarget = ("right " + V.brandTarget.local);
		if (slave.brand[leftTarget]) {
			p.append(`${His} ${leftTarget} is already marked with ${slave.brand[leftTarget]}. `);
		}
		if (slave.brand[rightTarget]) {
			p.append(`${His} ${rightTarget} is already marked with ${slave.brand[rightTarget]}. `);
		}
		p.append(`Brand ${him} now with ''${V.brandDesign.local}'' on the `); // todo: break out bold
		let _left;
		let _right;
		if (
			!(["upper arm", "lower arm", "wrist", "hand"].includes(V.brandTarget.local) && getLeftArmID(slave) !== 1) &&
			!(["thigh", "calf", "ankle", "foot"].includes(V.brandTarget.local) && getLeftLegID(slave) !== 1)
		) {
			_left = 1;// make next checks easier
			if (!cheat) {
				p.append(
					App.UI.DOM.link(
						"left",
						() => {
							V.brandApplied = 1;
							slave.brand[leftTarget] = check(V.brandDesign.local);
							cashX(forceNeg(V.modCost), "slaveMod", slave);
							V.degradation += 10;
						},
						[],
						"Body Modification"
					)
				);
			} else {
				p.append(
					App.UI.DOM.link(
						"left",
						() => {
							slave.brand[leftTarget] = check(V.brandDesign.local);
						},
					)
				);
			}

			if (!(["upper arm", "lower arm", "wrist", "hand"].includes(V.brandTarget.local) && getRightArmID(slave) !== 1) && !(["thigh", "calf", "ankle", "foot"].includes(V.brandTarget.local) && getRightLegID(slave) !== 1)) {
				_right = 1; // make next checks easier
			}
			if (_left && _right) {
				p.append(` ${V.brandTarget.local}, or the `);
			}
			if (_right) {
				if (!cheat) {
					p.append(
						App.UI.DOM.link(
							"right",
							() => {
								V.brandApplied = 1;
								slave.brand[rightTarget] = check(V.brandDesign.local);
								cashX(forceNeg(V.modCost), "slaveMod", slave);
								V.degradation += 10;
							},
							[],
							"Body Modification"
						)
					);
				} else {
					p.append(
						App.UI.DOM.link(
							"right",
							() => {
								slave.brand[rightTarget] = check(V.brandDesign.local);
							},
						)
					);
				}
			}
			p.append(`? `);
			if (!_left || !_right) {
				p.append(` ${V.brandTarget.local}`);
				App.UI.DOM.appendNewElement("span", p, `Branding will slightly reduce ${his} beauty but may slowly increase your reputation.`, "note");
			}
		}
	} else {
		if (slave.brand[V.brandTarget.local] === V.brandDesign.local) {
			p.append(`${He} already has ${V.brandDesign.local} on ${his} V.brandTarget.local.`);
		} else {
			if (!cheat) {
				p.append(
					App.UI.DOM.link(
						"Brand",
						() => {
							V.brandApplied = 1;
							slave.brand[V.brandTarget.local] = V.brandDesign.local;
							cashX(forceNeg(V.modCost), "slaveMod", slave);
							V.degradation += 10;
						},
						[],
						"Body Modification"
					)
				);
			} else {
				p.append(
					App.UI.DOM.link(
						"Brand",
						() => {
							slave.brand[V.brandTarget.local] = V.brandDesign.local;
						},
					)
				);
			}
			p.append(` with ${V.brandDesign.local} on the ${V.brandTarget.local}`);
			if (slave.brand[V.brandTarget.local]) {
				p.append(`, covering the "${slave.brand[V.brandTarget.local]}" that is already there? `);
			} else {
				p.append(`. `);
			}
			App.UI.DOM.appendNewElement("span", p, `Branding will slightly reduce ${his} beauty but may slowly increase your reputation.`, "note");
		}
	}
	el.append(p);
	return jQuery('#brand-selection').empty().append(el);

	function symbolBlock(brandList) {
		const div = document.createElement('div');
		div.classList.add("double-choices");
		div.style.textIndent = "0px";
		div.append(symbolOptions(brandList));
		return div;
	}

	function symbolOptions(brandList) {
		const list = App.Medicine.Modification.Brands[brandList];
		const array = [];
		for (const brand in list) {
			const frag = new DocumentFragment();
			if (!cheat && list[brand].hasOwnProperty("requirements")) {
				if (!list[brand].requirements(slave)) {
					continue;
				}
			}
			if (brandList === "FS") {
				App.UI.DOM.appendNewElement("span", frag, "FS ", "note");
			}
			frag.append(
				App.UI.DOM.link(
					list[brand].displayName,
					() => {
						V.brandDesign.local = check(brand);
						App.Medicine.Modification.Select.brand(slave, cheat); // Refresh display
					}
				)
			);
			array.push(frag);
		}
		return App.UI.DOM.generateLinksStrip(array);
	}

	function slaveBody() {
		const body = {};
		// Sorted head to toe
		// Head
		body.head = {};
		if (slave.earShape !== "none") {
			body.head.ears = "Ears";
		}
		body.head.cheek = "Cheeks";
		body.head.neck = "Neck";

		// Torso
		body.torso = {};
		body.torso.chest = "Chest";
		body.torso.breast = "Breasts";
		body.torso.back = "Back";
		body.torso["lower back"] = "Lower Back";
		body.torso.belly = "Belly";
		body.torso["pubic mound"] = "Pubic Mound";

		if (slave.dick > 0) {
			body.torso.penis = "Penis";
		}
		if (slave.balls > 0 && slave.scrotum > 0) {
			body.torso.testicle = "Testicles";
		}

		// Arms
		body.arms = {};
		body.arms.shoulder = "Shoulders";
		if (hasAnyNaturalArms(slave)) {
			body.arms["upper arm"] = "Arm, upper";
			body.arms["lower arm"] = "Arm, lower";
			body.arms.wrist = "Wrists";
			body.arms.hand = "Hands";
		}

		// Legs
		body.legs = {};
		body.legs.buttock = "Buttocks";
		if (hasAnyNaturalLegs(slave)) {
			body.legs.thigh = "Thighs";
			body.legs.calf = "Calves";
			body.legs.ankle = "Ankles";
			body.legs.foot = "Feet";
		}
		return body;
	}

	function partLinks(bodyPartObj) {
		const div = document.createElement("div");
		div.classList.add("double-choices");
		div.style.textIndent = "0px";
		const array = [];
		for (const bp in bodyPartObj) {
			array.push(
				App.UI.DOM.link(
					bodyPartObj[bp],
					() => {
						V.brandTarget.local = check(bp);
						App.Medicine.Modification.Select.brand(slave, cheat); // Refresh display
					}
				)
			);
		}
		div.append(App.UI.DOM.generateLinksStrip(array));
		return div;
	}

	function check(brand) {
		switch(brand) {
			case "a big helping of your favorite food":
				return 	"a big helping of " + V.PC.refreshment;
			default:
				return brand;
		}
	}
};
